// =========================== Atmega2560 CPU ׽Ʈ α׷ =================
//  CPU : ATmega2560-16M
//     ¥ : 2006-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#include <mega2560.h>						// CPU  

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <math.h>

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
void timer0_test(void);						// TIMER0 TEST
void timer1_test(void);						// TIMER1 TEST
void timer2_test(void);						// TIMER2 TEST
void timer3_test(void);						// TIMER3 TEST
void timer4_test(void);						// TIMER4 TEST
void timer5_test(void);						// TIMER5 TEST
void exint_test(void);						// EXINT0,1 TEST

void ad_polling_test(void);					// A/D   TEST
unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
void ad_interrupt_test(void);					// A/D ͷƮ  TEST
void ad_start(unsigned char adc_input);				// AD  (ͷƮ ) 

void eeprom_test(void);						// EEPROM TEST
void EEPROM_write(int addr,unsigned char data);			// EEPROM  
unsigned char EEPROM_read(int addr);				// EEPROM  

void sram_test(void);						// SRAM TEST

void com2_test(void);						// COM2 TEST
void putchar1(char c);						// COM2 1Ʈ ۽
void com3_test(void);						// COM3 TEST
void putchar2(char c);						// COM3 1Ʈ ۽
void com4_test(void);						// COM4 TEST
void putchar3(char c);						// COM4 1Ʈ ۽

void urx_string(char buff[]);					// Ʈ 
long atoh(char buff[]);						// ASCII TO HEX 

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
			else if(com1_rx_data == '5') timer3_test(); // TIMER3 TEST
			else if(com1_rx_data == '6') timer4_test(); // TIMER4 TEST
			else if(com1_rx_data == '7') timer5_test(); // TIMER5 TEST
			else if(com1_rx_data == '8') exint_test();  // EXINT0,1 TEST
			else if(com1_rx_data == '9') ad_polling_test();// A/D POLLING TEST
			else if(com1_rx_data == 'a') ad_interrupt_test(); // A/D POLLING TEST
			else if(com1_rx_data == 'b') eeprom_test(); // EEPROM TEST
			else if(com1_rx_data == 'c') sram_test();// SRAM TEST
			else if(com1_rx_data == 'd') com2_test();// COM2 TEST
			else if(com1_rx_data == 'e') com3_test();// COM3 TEST
			else if(com1_rx_data == 'f') com4_test();// COM4 TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("=================== MAIN MENU ==================\r\n");
	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	printf("- 2  : TIMER0 TEST                              \r\n");
	printf("- 3  : TIMER1 TEST                              \r\n");
	printf("- 4  : TIMER2 TEST                              \r\n");
	printf("- 5  : TIMER3 TEST                              \r\n");
	printf("- 6  : TIMER4 TEST                              \r\n");
	printf("- 7  : TIMER5 TEST                              \r\n");
	printf("- 8  : EXINT0,1,2,3,4,5,6,7 TEST                \r\n");
	printf("- 9  : A/D POLLING   TEST                       \r\n");
	printf("- a  : A/D INTERRUPT TEST                       \r\n");
	printf("- b  : EEPROM TEST                              \r\n");
	printf("- c  : SRAM   TEST                              \r\n");
	printf("- d  : COM2   TEST                              \r\n");
	printf("- e  : COM3   TEST                              \r\n");
	printf("- f  : COM4   TEST                              \r\n");
	printf("----------------- CPUPLAZA ---------------------\r\n");
}

// ============================== CPU_IO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("================ CPU I/O PORT TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("-------------------------------------------------\r\n");
// CPU PORT   
// PORTA[0..7] : OUT 
	PORTA=0xff;						// Ʈ  reg
	DDRA=0xff;						// Ʈ  reg(0Է,1)
// CPU PORT   
// PORTB[0..7] : OUT 
	PORTB=0xff;						// Ʈ  reg
	DDRB=0xff;						// Ʈ  reg(0Է,1)
// PORTC[0..5] : OUT 
	PORTC=0xff;						// Ʈ  reg
	DDRC=0xff;						// Ʈ  reg(0Է,1)
// PORTD[0..7] : OUT 
	PORTD=0xff;						// Ʈ  reg
	DDRD=0xff;						// Ʈ  reg(0Է,1)
// PORTE[2..7] : OUT 
	PORTE=0xfc;						// Ʈ  reg
	DDRE=0xfc;						// Ʈ  reg(0Է,1)
// PORTF[0..7] : OUT 
	PORTF=0xff;						// Ʈ  reg
	DDRF=0xff;						// Ʈ  reg(0Է,1)
// PORTG[0..5] : OUT 
	PORTG=0x27;						// Ʈ  reg
	DDRG=0x27;						// Ʈ  reg(0Է,1)
// PORTJ[0..7] : OUT 
	PORTJ=0xff;						// Ʈ  reg
	DDRJ=0x0ff;						// Ʈ  reg(0Է,1)
// PORTK[0..7] : OUT
        PORTK=0xff;	                			// Ʈ  reg
        DDRK=0xff;						// Ʈ  reg(0Է,1)
// PORTL[0..2] : OUT 
	PORTL=0xff;						// Ʈ  reg
	DDRL=0xff;						// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
// Timer/Counter0 (Overflow)
        TCCR0A=0x00;
	TCCR0B = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
				if(out_cnt == 8) PORTA = 0xff;	// PORTA CLEAR
				PORTB = ~(1 << (out_cnt-8));	// PORTB (ش Ʈ 0)
			}
			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
				if(out_cnt == 16) PORTB = 0xff;	// PORTB CLEAR
				PORTC = ~(1 << (out_cnt-16));	// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 24 && out_cnt < 32){	// PORTD 
				if(out_cnt == 24) PORTC = 0xff;	// PORTC CLEAR
				PORTD = ~(1 << (out_cnt-24));	// PORTD (ش Ʈ 0)
			}
			else if(out_cnt >= 32 && out_cnt < 38){	// PORTE 
				if(out_cnt == 32) PORTD = 0xff;	// PORTD CLEAR
				PORTE = ~(4 << (out_cnt-32));	// PORTE (ش Ʈ 0)
			}
			else if(out_cnt >= 38 && out_cnt < 46){	// PORTF 
				if(out_cnt == 38) PORTE = 0xfc;	// PORTE CLEAR
				PORTF = ~(1 << (out_cnt-38));	// PORTF (ش Ʈ 0)
			}
			else if(out_cnt >= 46 && out_cnt < 50){	// PORTG 
				if(out_cnt == 46) PORTF = 0xff;	// PORTF CLEAR
				if(out_cnt < 49) PORTG = ~(1 << (out_cnt-46));// PORTG (ش Ʈ 0)
				else PORTG = ~(1 << 5);		// PORTG (ش Ʈ 0)
			}
			else if(out_cnt >= 50 && out_cnt < 58){	// PORTJ 
				if(out_cnt == 50) PORTG = 0x27;	// PORTG CLEAR
				PORTJ = ~(1 << (out_cnt-50));	// PORTJ (ش Ʈ 0)
			}
			else if(out_cnt >= 58 && out_cnt < 66){	// PORTK 
				if(out_cnt == 58) PORTJ = 0xff;	// PORTJ CLEAR
				PORTK = ~(1 << (out_cnt-58));	// PORTK (ش Ʈ 0)
			}
			else if(out_cnt >= 66 && out_cnt < 74){	// PORTL 
				if(out_cnt == 66) PORTK = 0xff;	// PORTK CLEAR
				PORTL = ~(1 << (out_cnt-66));	// PORTL (ش Ʈ 0)
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 75) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTA = 0xff;
				PORTB = 0xff;
				PORTC = 0xff;
				PORTD = 0xff;
				PORTE = 0xfc;
				PORTF = 0xff;
				PORTG = 0x27;
				PORTJ = 0xff;
				PORTK = 0xff;
				PORTL = 0xff;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A = 0x00;
	TCCR0B = 0x00;
	TCNT0  = 0x00;
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTA
	PORTA=0x00;						// Ʈ  reg
	DDRA=0x00;						// Ʈ  reg(0Է,1)
// PORTB
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)
// PORTC
	PORTC=0x00;						// Ʈ  reg
	DDRC=0x00;						// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;						// Ʈ  reg(0Է,1)
// PORTE
	PORTE=0x00;						// Ʈ  reg
	DDRE=0x00;						// Ʈ  reg(0Է,1)
// PORTF
	PORTF=0x00;						// Ʈ  reg
	DDRF=0x00;						// Ʈ  reg(0Է,1)
// PORTG
	PORTG=0x00;						// Ʈ  reg
	DDRG=0x00;						// Ʈ  reg(0Է,1)
// PORTJ
	PORTJ=0x00;						// Ʈ  reg
	DDRJ=0x00;						// Ʈ  reg(0Է,1)
// PORTK
	PORTK=0x00;						// Ʈ  reg
	DDRK=0x00;						// Ʈ  reg(0Է,1)
// PORTL
	PORTL=0x00;						// Ʈ  reg
	DDRL=0x00;						// Ʈ  reg(0Է,1)
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER0 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer0_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER0 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter0 (Overflow)
	TCCR0A = 0x00;
	TCCR0B = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT0 = 99;						// 255-156 = 99	
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){				// 999.84ms üũ
			printf("TIMER0 Overflow Interrupt\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A = 0x00;
	TCCR0B = 0x00;
	TCNT0  = 0x00;
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER1 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer1_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER1 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER1 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter1 (Overflow)
	TCCR1A=0x00;
	TCCR1B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT1H=0xf6;  						// 65535 - 2500 = 63035
	TCNT1L=0x3b;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;
	TIMSK1 |= 0x01;						// TIMER1 ͷƮ 㰡
	
	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 1s üũ
			printf("TIMER1 Overflow Interrupt\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;
	OCR1CH=0x00;
	OCR1CL=0x00;
	TIMSK1 &= 0xfe;						// TIMER1 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER2 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer2_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER2 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER2 Overfow 9.9984ms         \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter2 (Overflow)
	ASSR=0x00;
	TCCR2A=0x00;
	TCCR2B=0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	TCNT2 = 99;						// 255-156 = 99
	OCR2A=0x00;
	OCR2B=0x00;
	TIMSK2 |= 0x01;						// TIMER2 ͷƮ 㰡
	
	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){				// 999.84ms üũ
			printf("TIMER2 Overflow Interrupt\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter2 
	ASSR=0x00;
	TCCR2A=0x00;
	TCCR2B=0x00;
	TCNT2=0x00;
	OCR2A=0x00;
	OCR2B=0x00;
	TIMSK2 &= 0xfe;						// TIMER2 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER3 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer3_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER3 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER3 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter3 (Overflow)
	TCCR3A=0x00;
	TCCR3B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	TCNT3L=0x3b;
	ICR3H=0x00;
	ICR3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;
	TIMSK3 |= 0x01;						// TIMER3 ͷƮ 㰡

	timer3_cnt = 0;						// TIMER3 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer3_cnt >= 100){				// 1s üũ
			printf("TIMER3 Overflow Interrupt\r\n");
			timer3_cnt = 0;
		}
	}

// Timer/Counter3 
	TCCR3A=0x00;
	TCCR3B=0x00;
	TCNT3H=0x00;
	TCNT3L=0x00;
	ICR3H=0x00;
	ICR3L=0x00;
	OCR3AH=0x00;
	OCR3AL=0x00;
	OCR3BH=0x00;
	OCR3BL=0x00;
	OCR3CH=0x00;
	OCR3CL=0x00;
	TIMSK3 &= 0xfe;						// TIMER3 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER4 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer4_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER4 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER4 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter4 (Overflow)
	TCCR4A=0x00;
	TCCR4B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT4H=0xf6;  						// 65535 - 2500 = 63035
	TCNT4L=0x3b;
	ICR4H=0x00;
	ICR4L=0x00;
	OCR4AH=0x00;
	OCR4AL=0x00;
	OCR4BH=0x00;
	OCR4BL=0x00;
	OCR4CH=0x00;
	OCR4CL=0x00;
	TIMSK4 |= 0x01;						// TIMER4 ͷƮ 㰡

	timer4_cnt = 0;						// TIMER4 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer4_cnt >= 100){				// 1s üũ
			printf("TIMER4 Overflow Interrupt\r\n");
			timer4_cnt = 0;
		}
	}

// Timer/Counter4 
	TCCR4A=0x00;
	TCCR4B=0x00;
	TCNT4H=0x00;
	TCNT4L=0x00;
	ICR4H=0x00;
	ICR4L=0x00;
	OCR4AH=0x00;
	OCR4AL=0x00;
	OCR4BH=0x00;
	OCR4BL=0x00;
	OCR4CH=0x00;
	OCR4CL=0x00;
	TIMSK4 &= 0xfe;						// TIMER4 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER5 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer5_test(void)
{
int exit_flg = 0;

	printf("=================== TIMER5 TEST =================\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt    : TIMER5 Overfow 10.0ms           \r\n");
	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	printf("-------------------------------------------------\r\n");

// Timer/Counter5 (Overflow)
	TCCR5A=0x00;
	TCCR5B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	TCNT5H=0xf6;  						// 65535 - 2500 = 63035
	TCNT5L=0x3b;
	ICR5H=0x00;
	ICR5L=0x00;
	OCR5AH=0x00;
	OCR5AL=0x00;
	OCR5BH=0x00;
	OCR5BL=0x00;
	OCR5CH=0x00;
	OCR5CL=0x00;
	TIMSK5 |= 0x01;						// TIMER5 ͷƮ 㰡

	timer5_cnt = 0;						// TIMER5 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer5_cnt >= 100){				// 1s üũ
			printf("TIMER5 Overflow Interrupt\r\n");
			timer5_cnt = 0;
		}
	}

// Timer/Counter5 
	TCCR5A=0x00;
	TCCR5B=0x00;
	TCNT5H=0x00;
	TCNT5L=0x00;
	ICR5H=0x00;
	ICR5L=0x00;
	OCR5AH=0x00;
	OCR5AL=0x00;
	OCR5BH=0x00;
	OCR5BL=0x00;
	OCR5CH=0x00;
	OCR5CL=0x00;
	TIMSK5 &= 0xfe;						// TIMER5 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("=================== EXINT0,1 TEST ===============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- interrupt : INT0 Falling Edge                  \r\n");
	printf("-             INT1 Falling Edge                  \r\n");
	printf("-             INT2 Falling Edge                  \r\n");
	printf("-             INT3 Falling Edge                  \r\n");
	printf("-             INT4 Falling Edge                  \r\n");
	printf("-             INT5 Falling Edge                  \r\n");
	printf("-             INT6 Falling Edge                  \r\n");
	printf("-             INT7 Falling Edge                  \r\n");
	printf("-------------------------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
// INT2 Mode: Falling Edge
// INT3 Mode: Falling Edge
// INT4 Mode: Falling Edge
// INT5 Mode: Falling Edge
// INT6 Mode: Falling Edge
// INT7 Mode: Falling Edge
	EICRA=0xAA;
	EICRB=0xAA;
	EIMSK=0xFF;
	EIFR=0xFF;

	exint0_flg = exint1_flg = exint2_flg = 0;		// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
			printf("EXINT2 Interrupt\r\n");
			exint2_flg = 0;
		}
		if(exint3_flg){					// EXINT3 ͷƮ ÷ üũ
			printf("EXINT3 Interrupt\r\n");
			exint3_flg = 0;
		}
		if(exint4_flg){					// EXINT4 ͷƮ ÷ üũ
			printf("EXINT4 Interrupt\r\n");
			exint4_flg = 0;
		}
		if(exint5_flg){					// EXINT5 ͷƮ ÷ üũ
			printf("EXINT5 Interrupt\r\n");
			exint5_flg = 0;
		}
		if(exint6_flg){					// EXINT6 ͷƮ ÷ üũ
			printf("EXINT6 Interrupt\r\n");
			exint6_flg = 0;
		}
		if(exint7_flg){					// EXINT7 ͷƮ ÷ üũ
			printf("EXINT7 Interrupt\r\n");
			exint7_flg = 0;
		}
	}

// External Interrupt(s) 
	EICRA=0x00;
	EICRB=0x00;
	EIMSK=0x00;
	EIFR=0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_polling_test(void)
{
unsigned datau;
int exit_flg = 0;

	printf("================= A/D POLLING TEST ==============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0 READ                                  \r\n");
	printf("- 2  : CH1 READ                                  \r\n");
	printf("- 3  : CH2 READ                                  \r\n");
	printf("- 4  : CH3 READ                                  \r\n");
	printf("- 5  : CH4 READ                                  \r\n");
	printf("- 6  : CH5 READ                                  \r\n");
	printf("- 7  : CH6 READ                                  \r\n");
	printf("- 8  : CH7 READ                                  \r\n");
	printf("-------------------------------------------------\r\n");

// Digital input buffers on
//  ADC0: On, ADC1: On, ADC2: On, ADC3: On, ADC4: On, ADC5: On, ADC6: On, ADC7: On
	DIDR0=0x00;
// Digital input buffers on
// ADC8: On, ADC9: On, ADC10: On, ADC11: On, ADC12: On, ADC13: On, ADC14: On, ADC15: On
	DIDR2=0x00;
// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
			com1_rx_eflg = 0;
		}
	}

// ADC initialization 
	DIDR0=0xff;
	DIDR2=0xff;
	ADMUX = 0x00;
	ADCSRA = 0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
unsigned int ad_read(unsigned char adc_input)
{
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
	while((ADCSRA & 0x10) == 0);				//  Ϸ 
	ADCSRA |= 0x10;						// AD ÷ Ŭ
	return ADCW;
}

// ============================== A/D INTERRUPT TEST ==========================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_interrupt_test(void)
{
int exit_flg = 0;

	printf("================ A/D INTEERRUPT TEST ============\r\n");
	printf("- 0  : TOP menu                                  \r\n");
	printf("- 1  : CH0 READ                                  \r\n");
	printf("- 2  : CH1 READ                                  \r\n");
	printf("- 3  : CH2 READ                                  \r\n");
	printf("- 4  : CH3 READ                                  \r\n");
	printf("- 5  : CH4 READ                                  \r\n");
	printf("- 6  : CH5 READ                                  \r\n");
	printf("- 7  : CH6 READ                                  \r\n");
	printf("- 8  : CH7 READ                                  \r\n");
	printf("-------------------------------------------------\r\n");

// Digital input buffers on
//  ADC0: On, ADC1: On, ADC2: On, ADC3: On, ADC4: On, ADC5: On, ADC6: On, ADC7: On
	DIDR0=0x00;
// Digital input buffers on
// ADC8: On, ADC9: On, ADC10: On, ADC11: On, ADC12: On, ADC13: On, ADC14: On, ADC15: On
	DIDR2=0x00;
// ADC initialization 
	ADMUX = 0x00;						//   AREF
	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ

	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	adc_int_ch = 0;						// ADC CH = CH0
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') ad_start(0);// CH0 
			else if(com1_rx_data == '2') ad_start(1);// CH1 
			else if(com1_rx_data == '3') ad_start(2);// CH2 
			else if(com1_rx_data == '4') ad_start(3);// CH3 
			else if(com1_rx_data == '5') ad_start(4);// CH4 
			else if(com1_rx_data == '6') ad_start(5);// CH5 
			else if(com1_rx_data == '7') ad_start(6);// CH6 
			else if(com1_rx_data == '8') ad_start(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
			com1_rx_eflg = 0;
		}
		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷ 
			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
			adc_int_flg = 0;
		}
	}

// ADC initialization 
	DIDR0=0xff;
	DIDR2=0xff;
	ADMUX = 0x00;
	ADCSRA = 0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
void ad_start(unsigned char adc_input)
{
	adc_int_ch = adc_input;					// ADC CH 
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
}

// ================================ EEPROM TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void eeprom_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int i,j,cnt,exit_flg = 0;
unsigned int saddr,ecnt;

	printf("============== INTERNAL EEPROM TEST =============\r\n");
	printf("- 0 : TOP menu                                   \r\n");
	printf("  1 : Read  Data(000-1fffh)                       \r\n");
	printf("  2 : Write Data(000-1fffh)                       \r\n");
	printf("-------------------------------------------------\r\n");

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1'){
				i = j = cnt = 0;
				printf("\r\nREAD(###(Add),***(Count)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
				    			buff2[j++] = ch;
				    			buff2[j] = 0x0;
						}
			    		}
				    	ch = buff[i++];
				}
				if(cnt == 1){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
					printf("%04X > ",saddr);// ּ ǥ
					cnt = 0;
			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ	
						uch = EEPROM_read(saddr);//  
						printf("%02X ",uch);// Ÿ ǥ
						cnt++;
						if(cnt == 16){// 1 ǥ
							cnt = 0;
							if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
						}
				    	}
					printf("\r\nRead OK\r\n");
				}
			}
			else if(com1_rx_data == '2'){
				i = j = cnt = 0;
				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
							buff2[j++] = ch;
							buff2[j] = 0x0;
						}
						else if(cnt == 2){
							buff3[j++] = ch;
							buff3[j] = 0x0;
						}
					}
					ch = buff[i++];
				}
				if(cnt == 2){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
					printf("SRAM Data Write OK\r\n");
				}
			}
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
	}
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EEPROM DATA READ ============================
// [μ] int addr
// Item1:  ּ(0 - 8191)
// []  (00 - ff)
// ----------------------------------------------------------------------------
unsigned char EEPROM_read(int addr)
{
unsigned char ch;

	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EECR |= 0x01;
	ch = EEDR;
	return(ch);
}

// ================================= EEPROM DATA  =========================
// [μ] int addr,unsigned char data
// Item1:  ּ(0 - 8191)
// Item2:  (00 - ff)
// ----------------------------------------------------------------------------
void EEPROM_write(int addr,unsigned char data)
{
	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EEDR = data;
	EECR |= 0x04;
	EECR |= 0x02;
}

// ============================== SRAM ׽Ʈ α׷ ========================
// [μ] void
// ---------------------------------------------------------------------------
void sram_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int i,j,cnt,exit_flg = 0;
unsigned int saddr,ecnt;
unsigned char *sram_base = (unsigned char*)0x0;

	printf("============ SRAM TEST ============\r\n");
	printf("- 0 : TOP MENU                    -\r\n");
	printf("- 1 : Read  Data(0000-ffffh)      -\r\n");
	printf("- 2 : Write Data(0000-ffffh)      -\r\n");
	printf("-----------------------------------\r\n");
// External SRAM page configuration:
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): None
	MCUCR=0x00;
	XMCRA=0x80;

	com1_rx_eflg = 0;
	while(exit_flg == 0){
	    if(com1_rx_eflg == 1){
			com1_rx_eflg = 0;
			switch(com1_rx_data){
			    case   '0': exit_flg = 1; break;
			    case   '1': i = j = cnt = 0;
					printf("\r\nREAD(#####(A),***(C)) > ");
					urx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
				    		if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
						}
						else{
							if(cnt == 0){
					    			buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
					    			buff2[j++] = ch;
					    			buff2[j] = 0x0;
							}
				    		}
					    		ch = buff[i++];
					}
					if(cnt == 1){		// ˻ 
						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
						ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
						printf("%04X > ",saddr);// ּ ǥ
						cnt = 0;
				   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ	
							uch = sram_base[saddr];//  
							printf("%02X ",uch);// Ÿ ǥ
							cnt++;
							if(cnt == 16){// 1 ǥ
								cnt = 0;
								if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
							}
					    	}
						printf("\r\nRead OK\r\n");
					}
					break;
			    case  '2' : i = j = cnt = 0;
					printf("\r\nWRITE(#####(A),***(C),**(D)) > ");
					urx_string(buff);
					ch = buff[i++];		//  ˻ ڷ 
					while(ch != 0x0){
						if((ch == ':') || (ch == ',') || (ch == ' ')){
							j = 0;
							cnt++;
						}
						else{
							if(cnt == 0){
								buff1[j++] = ch;
								buff1[j] = 0x0;
							}
							else if(cnt == 1){
								buff2[j++] = ch;
								buff2[j] = 0x0;
							}
							else if(cnt == 2){
								buff3[j++] = ch;
								buff3[j] = 0x0;
							}
						}
							    ch = buff[i++];
					}
					if(cnt == 2){		// ˻ 
						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
						ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
						uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
						for(i = 0; i <= ecnt; i++,saddr++){
							sram_base[saddr] = uch;//  
						}
//						for(i = 0; i < ecnt; i++) sram_base[saddr+i] = uch;//  
						printf("SRAM Data Write OK\r\n");
					}
					break;
		    	    default   : break;
			}
		}
	}
	com1_rx_eflg = 0;
	main_menu_disp();					// ޴ ǥ
	MCUCR=0x00;						// clear exram config
	XMCRA=0x00;
}

// ==================================== COM2 TEST =============================
// [μ] void
// ----------------------------------------------------------------------------
void com2_test(void)
{
int exit_flg = 0;

	printf("============== COM2 LOOPBACK TEST ==============\r\n");
	printf("- 0  : RETURN TOP MENU                          \r\n");
	printf("------------------------------------------------\r\n");
	
	com1_rx_eflg = com2_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;
			else putchar1(com1_rx_data);		// COM2 send
			com1_rx_eflg = 0;
		}
		if(com2_rx_eflg){				// COM2  ˻
			putchar(com2_rx_data);			// COM1 send
			com2_rx_eflg = 0;
		}
	}
	main_menu_disp();					// ޴ ǥ
}

// ============================ COM2 1Ʈ ۽ ===========================
// [μ] char c					     
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar1(char c)
{
	while((UCSR1A & DATA_REGISTER_EMPTY)==0);
	UDR1 = c;
}

// ==================================== COM3 TEST =============================
// [μ] void
// ----------------------------------------------------------------------------
void com3_test(void)
{
int exit_flg = 0;

	printf("============== COM3 LOOPBACK TEST ==============\r\n");
	printf("- 0  : RETURN TOP MENU                          \r\n");
	printf("------------------------------------------------\r\n");
	
	com1_rx_eflg = com3_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;
			else putchar2(com1_rx_data);		// COM3 send
			com1_rx_eflg = 0;
		}
		if(com3_rx_eflg){				// COM3  ˻
			putchar(com3_rx_data);			// COM1 send
			com3_rx_eflg = 0;
		}
	}
	main_menu_disp();					// ޴ ǥ
}

// ============================ COM3 1Ʈ ۽ ===========================
// [μ] char c					     
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar2(char c)
{
	while((UCSR2A & DATA_REGISTER_EMPTY)==0);
	UDR2 = c;
}

// ==================================== COM4 TEST =============================
// [μ] void
// ----------------------------------------------------------------------------
void com4_test(void)
{
int exit_flg = 0;

	printf("============== COM4 LOOPBACK TEST ==============\r\n");
	printf("- 0  : RETURN TOP MENU                          \r\n");
	printf("------------------------------------------------\r\n");
	
	com1_rx_eflg = com4_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;
			else putchar3(com1_rx_data);		// COM4 send
			com1_rx_eflg = 0;
		}
		if(com4_rx_eflg){				// COM4  ˻
			putchar(com4_rx_data);			// COM1 send
			com4_rx_eflg = 0;
		}
	}
	main_menu_disp();					// ޴ ǥ
}

// ============================ COM3 1Ʈ ۽ ===========================
// [μ] char c					     
// Item1  ۽ 
// ----------------------------------------------------------------------------
void putchar3(char c)
{
	while((UCSR3A & DATA_REGISTER_EMPTY)==0);
	UDR3 = c;
}

// ============================ κ ڿ  ====================
// [μ] char buff[]					     
// Item1   Ÿ  (ִ 30)			     
// ----------------------------------------------------------------------------
void urx_string(char buff[])
{
char ch;
int exit_flg = 0,scnt = 0;

	com1_rx_eflg = 0;
	buff[0] = 0x0;						//  ũ
	while(exit_flg == 0){
	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
	    ch = com1_rx_data;					//  Ÿ ε
	    ch = toupper(ch);					//  ȯ
	    if(ch == 0x08){					// BSŰ м
			if(scnt == 0) putchar(0x07);		//  溸 ۽
			else{					// 1ڸ 
			    putchar(0x08);
			    putchar(' ');
			    putchar(0x08);
			    scnt--;
			}
	    }
	    else if(ch == 0x0d){
			exit_flg = 1;				// Ż  ON
			buff[scnt] = 0x0;
			printf("\r\n");
	    }
	    else{
			buff[scnt++] = ch;			// ڷ 
			putchar(ch);
			if(scnt >= 30){ 			//   ʰ 
			    scnt = 29;
			    putchar(0x08);
			    putchar(0x07);
			}
	    }
	}
}

// ========================== ASCII͸ HEXͷ ȯ ==================
// [μ] unsigned char buff[]					    
// Item1  ȯ  					    
// [] 0 - 7fffffffh 					    
// ----------------------------------------------------------------------------
long atoh(char buff[])
{
char ch;
int i = 0;
long data = 0;

	ch = buff[i++]; 					//  ε
	ch = toupper(ch);					// 빮 ȯ
	while(ch != 0){
		ch = ch - '0';              			// 0 - 9 ȯ 
		if(ch > 9) ch = ch - 7;				// A - F ȯ
		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
		else ch = ch & 0x0f;
		data = data << 4;				// ȯ  
		data |= ch;
		ch = buff[i++];					//  ε
		ch = toupper(ch);				// 빮 ȯ 
	}
	return(data);
}
