
;CodeVisionAVR C Compiler V1.25.3 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega2560
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega2560
	#pragma AVRPART MEMORY PROG_FLASH 262144
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 8192
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x200

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU RAMPZ=0x3B
	.EQU EIND=0x3C
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x74
	.EQU XMCRB=0x75
	.EQU GPIOR0=0x1E
	.EQU GPIOR1=0x2A
	.EQU GPIOR2=0x2B

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRA,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x2000)
	LDI  R25,HIGH(0x2000)
	LDI  R26,LOW(0x200)
	LDI  R27,HIGH(0x200)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

	OUT  RAMPZ,R24
	OUT  EIND,R24

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x21FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x21FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x600)
	LDI  R29,HIGH(0x600)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x600
;       1 // =========================== Atmega2560 CPU ׽Ʈ α׷ =================
;       2 //  CPU : ATmega2560-16M
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega2560.h>						// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 #include <math.h>
;      17 
;      18 //  
;      19 #include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;      20 // =================================== CPUʱȭ ͷƮ ===================
;      21 //      : CPU  ϰ ͷƮ  ƾ .
;      22 // ----------------------------------------------------------------------------
;      23 //   
;      24 #define RXB8 1
;      25 #define TXB8 0
;      26 #define UPE 2
;      27 #define OVR 3
;      28 #define FE 4
;      29 #define UDRE 5
;      30 #define RXC 7
;      31 
;      32 #define FRAMING_ERROR (1<<FE)
;      33 #define PARITY_ERROR (1<<UPE)
;      34 #define DATA_OVERRUN (1<<OVR)
;      35 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      36 #define RX_COMPLETE (1<<RXC)
;      37 
;      38 //  
;      39 char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
;      40 char com2_rx_data,com2_rx_eflg = 0;				// COM2   ͷƮ  /÷
;      41 char com3_rx_data,com3_rx_eflg = 0;				// COM3   ͷƮ  /÷
;      42 char com4_rx_data,com4_rx_eflg = 0;				// COM4   ͷƮ  /÷
;      43 
;      44 int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
;      45 int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
;      46 int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī
_timer2_cnt:
	.BYTE 0x2
;      47 int timer3_cnt = 0;						// Ÿ̸3 ͷƮ  ī
_timer3_cnt:
	.BYTE 0x2
;      48 int timer4_cnt = 0;						// Ÿ̸4 ͷƮ  ī
_timer4_cnt:
	.BYTE 0x2
;      49 int timer5_cnt = 0;						// Ÿ̸5 ͷƮ  ī
_timer5_cnt:
	.BYTE 0x2
;      50 
;      51 int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
_exint0_flg:
	.BYTE 0x2
;      52 int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
_exint1_flg:
	.BYTE 0x2
;      53 int exint2_flg = 0;						// EXINT2 ͷƮ  ÷
_exint2_flg:
	.BYTE 0x2
;      54 int exint3_flg = 0;						// EXINT3 ͷƮ  ÷
_exint3_flg:
	.BYTE 0x2
;      55 int exint4_flg = 0;						// EXINT4 ͷƮ  ÷
_exint4_flg:
	.BYTE 0x2
;      56 int exint5_flg = 0;						// EXINT5 ͷƮ  ÷
_exint5_flg:
	.BYTE 0x2
;      57 int exint6_flg = 0;						// EXINT6 ͷƮ  ÷
_exint6_flg:
	.BYTE 0x2
;      58 int exint7_flg = 0;						// EXINT7 ͷƮ  ÷
_exint7_flg:
	.BYTE 0x2
;      59 
;      60 unsigned int adc_int_data = 0;					// ADC ͷƮ  
_adc_int_data:
	.BYTE 0x2
;      61 int adc_int_ch = 0;						// ADC CH ͷƮ 
_adc_int_ch:
	.BYTE 0x2
;      62 int adc_int_flg = 0;						// ADC ͷƮ  ÷
_adc_int_flg:
	.BYTE 0x2
;      63 
;      64 // ===================================== CPUʱȭ ============================
;      65 // [μ] void
;      66 // ----------------------------------------------------------------------------
;      67 void cpu_setup(void)
;      68 {

	.CSEG
_cpu_setup:
;      69 #pragma optsize-
;      70 	CLKPR=0x80;						// Crystal Oscillator division factor: 1
	LDI  R30,LOW(128)
	STS  97,R30
;      71 	CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;      72 #ifdef _OPTIMIZE_SIZE_
;      73 #pragma optsize+
;      74 #endif
;      75 
;      76 // PortA 
;      77 	PORTA=0x00;						// Ʈ  reg
	CALL SUBOPT_0x0
;      78 	DDRA=0x00;						// Ʈ  reg(0Է,1)
;      79 // PortB 
;      80 	PORTB=0x00;						// Ʈ  reg
;      81 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;      82 
;      83 // PortC 
;      84 	PORTC=0x00;						// Ʈ  reg
;      85 	DDRC=0x00;                                              // Ʈ  reg(0Է,1)
;      86 
;      87 // PortD 
;      88 	PORTD=0x00;						// Ʈ  reg
;      89 	DDRD=0x00;                                              // Ʈ  reg(0Է,1)
;      90 
;      91 // PortE 
;      92 	PORTE=0x00;						// Ʈ  reg
;      93 	DDRE=0x00;                                              // Ʈ  reg(0Է,1)
;      94 // PortF 
;      95 	PORTF=0x00;						// Ʈ  reg
;      96 	DDRF=0x00;                                              // Ʈ  reg(0Է,1)
;      97 // PortG 
;      98 	PORTG=0x00;						// Ʈ  reg
;      99 	DDRG=0x00;                                              // Ʈ  reg(0Է,1)
;     100 // PortJ 
;     101 	PORTJ=0x00;						// Ʈ  reg
;     102 	DDRJ=0x00;                                              // Ʈ  reg(0Է,1)
;     103 // PortK 
;     104 	PORTK=0x00;						// Ʈ  reg
;     105 	DDRK=0x00;                                              // Ʈ  reg(0Է,1)
;     106 // PortL 
;     107 	PORTL=0x00;						// Ʈ  reg
;     108 	DDRL=0x00;                                              // Ʈ  reg(0Է,1)
;     109 
;     110 // Timer/Counter0 
;     111 	TCCR0A=0x00;
	CALL SUBOPT_0x1
;     112 	TCCR0B=0x00;
;     113 	TCNT0=0x00;
;     114 	OCR0A=0x00;
;     115 	OCR0B=0x00;
;     116 
;     117 // Timer/Counter1 
;     118 	TCCR1A=0x00;
	CALL SUBOPT_0x2
;     119 	TCCR1B=0x00;
;     120 	TCNT1H=0x00;
;     121 	TCNT1L=0x00;
;     122 	ICR1H=0x00;
;     123 	ICR1L=0x00;
;     124 	OCR1AH=0x00;
;     125 	OCR1AL=0x00;
;     126 	OCR1BH=0x00;
;     127 	OCR1BL=0x00;
;     128 	OCR1CH=0x00;
;     129 	OCR1CL=0x00;
;     130 
;     131 // Timer/Counter2 
;     132 	ASSR=0x00;
	CALL SUBOPT_0x3
;     133 	TCCR2A=0x00;
;     134 	TCCR2B=0x00;
	CALL SUBOPT_0x4
;     135 	TCNT2=0x00;
;     136 	OCR2A=0x00;
;     137 	OCR2B=0x00;
;     138 
;     139 // Timer/Counter3 
;     140 	TCCR3A=0x00;
	CALL SUBOPT_0x5
;     141 	TCCR3B=0x00;
;     142 	TCNT3H=0x00;
;     143 	TCNT3L=0x00;
;     144 	ICR3H=0x00;
;     145 	ICR3L=0x00;
;     146 	OCR3AH=0x00;
;     147 	OCR3AL=0x00;
;     148 	OCR3BH=0x00;
;     149 	OCR3BL=0x00;
;     150 	OCR3CH=0x00;
;     151 	OCR3CL=0x00;
;     152 
;     153 // Timer/Counter4 
;     154 	TCCR4A=0x00;
	CALL SUBOPT_0x6
;     155 	TCCR4B=0x00;
;     156 	TCNT4H=0x00;
;     157 	TCNT4L=0x00;
;     158 	ICR4H=0x00;
;     159 	ICR4L=0x00;
;     160 	OCR4AH=0x00;
;     161 	OCR4AL=0x00;
;     162 	OCR4BH=0x00;
;     163 	OCR4BL=0x00;
;     164 	OCR4CH=0x00;
;     165 	OCR4CL=0x00;
;     166 
;     167 // Timer/Counter5 
;     168 	TCCR5A=0x00;
	CALL SUBOPT_0x7
;     169 	TCCR5B=0x00;
;     170 	TCNT5H=0x00;
;     171 	TCNT5L=0x00;
;     172 	ICR5H=0x00;
;     173 	ICR5L=0x00;
;     174 	OCR5AH=0x00;
;     175 	OCR5AL=0x00;
;     176 	OCR5BH=0x00;
;     177 	OCR5BL=0x00;
;     178 	OCR5CH=0x00;
;     179 	OCR5CL=0x00;
;     180 
;     181 // External Interrupt(s) 
;     182 // INT0: Off
;     183 // INT1: Off
;     184 // INT2: Off
;     185 // INT3: Off
;     186 // INT4: Off
;     187 // INT5: Off
;     188 // INT6: Off
;     189 // INT7: Off
;     190 	EICRA=0x00;
	CALL SUBOPT_0x8
;     191 	EICRB=0x00;
;     192 	EIMSK=0x00;
;     193 
;     194 // PCINT0  : Off
;     195 // PCINT1  : Off
;     196 // PCINT2  : Off
;     197 // PCINT3  : Off
;     198 // PCINT4  : Off
;     199 // PCINT5  : Off
;     200 // PCINT6  : Off
;     201 // PCINT7  : Off
;     202 // PCINT8  : Off
;     203 // PCINT9  : Off
;     204 // PCINT10 : Off
;     205 // PCINT11 : Off
;     206 // PCINT12 : Off
;     207 // PCINT13 : Off
;     208 // PCINT14 : Off
;     209 // PCINT15 : Off
;     210 // PCINT16 : Off
;     211 // PCINT17 : Off
;     212 // PCINT18 : Off
;     213 // PCINT19 : Off
;     214 // PCINT20 : Off
;     215 // PCINT21 : Off
;     216 // PCINT22 : Off
;     217 // PCINT23 : Off
;     218 	PCMSK0=0x00;
	STS  107,R30
;     219 	PCMSK1=0x00;
	LDI  R30,LOW(0)
	STS  108,R30
;     220 	PCMSK2=0x00;
	STS  109,R30
;     221 	PCICR=0x00;
	STS  104,R30
;     222 
;     223 // Timer(s)/Counter(s) Interrupt(s) 
;     224 	TIMSK0=0x00;
	STS  110,R30
;     225 	TIMSK1=0x00;
	STS  111,R30
;     226 	TIMSK2=0x00;
	STS  112,R30
;     227 	TIMSK3=0x00;
	STS  113,R30
;     228 	TIMSK4=0x00;
	STS  114,R30
;     229 	TIMSK5=0x00;
	STS  115,R30
;     230 
;     231 //  ʱȭ(COM1)
;     232 // 19200Bps, 8Data, 1 Stop, No Parity
;     233 	UCSR0A=0x00;
	STS  192,R30
;     234 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	STS  193,R30
;     235 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  194,R30
;     236 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  197,R30
;     237 	UBRR0L=0x33;
	LDI  R30,LOW(51)
	STS  196,R30
;     238 
;     239 //  ʱȭ(COM2)
;     240 // 19200Bps, 8Data, 1 Stop, No Parity
;     241 	UCSR1A=0x00;
	LDI  R30,LOW(0)
	STS  200,R30
;     242 	UCSR1B=0x98;
	LDI  R30,LOW(152)
	STS  201,R30
;     243 	UCSR1C=0x06;
	LDI  R30,LOW(6)
	STS  202,R30
;     244 	UBRR1H=0x00;
	LDI  R30,LOW(0)
	STS  205,R30
;     245 	UBRR1L=0x33;
	LDI  R30,LOW(51)
	STS  204,R30
;     246 
;     247 //  ʱȭ(COM3)
;     248 // 19200Bps, 8Data, 1 Stop, No Parity
;     249 	UCSR2A=0x00;
	LDI  R30,LOW(0)
	STS  208,R30
;     250 	UCSR2B=0x98;
	LDI  R30,LOW(152)
	STS  209,R30
;     251 	UCSR2C=0x06;
	LDI  R30,LOW(6)
	STS  210,R30
;     252 	UBRR2H=0x00;
	LDI  R30,LOW(0)
	STS  213,R30
;     253 	UBRR2L=0x33;
	LDI  R30,LOW(51)
	STS  212,R30
;     254 
;     255 //  ʱȭ(COM4)
;     256 // 19200Bps, 8Data, 1 Stop, No Parity
;     257 	UCSR3A=0x00;
	LDI  R30,LOW(0)
	STS  304,R30
;     258 	UCSR3B=0x98;
	LDI  R30,LOW(152)
	STS  305,R30
;     259 	UCSR3C=0x06;
	LDI  R30,LOW(6)
	STS  306,R30
;     260 	UBRR3H=0x00;
	LDI  R30,LOW(0)
	STS  309,R30
;     261 	UBRR3L=0x33;
	LDI  R30,LOW(51)
	STS  308,R30
;     262 
;     263 // External SRAM page configuration:
;     264 //              -              / 0000h - FFFFh
;     265 // Lower page wait state(s): None
;     266 // Upper page wait state(s): None
;     267 //	MCUCR=0x80;
;     268 //	XMCRA=0x00;
;     269 
;     270 // Analog Comparator 
;     271 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     272 	ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     273 
;     274 // Global enable interrupts
;     275 #asm("sei")
	sei
;     276 }
	RET
;     277 
;     278 // =============================== COM1 ͷƮ ===========================
;     279 // [μ] void
;     280 // ----------------------------------------------------------------------------
;     281 #pragma savereg-
;     282 interrupt [USART0_RXC] void uart0_rx_isr(void)
;     283 {
_uart0_rx_isr:
;     284 char status,data;
;     285 #asm
;     286 	push r26
	push r26
;     287 	push r27
	push r27
;     288 	push r30
	push r30
;     289 	push r31
	push r31
;     290 	in   r26,sreg
	in   r26,sreg
;     291 	push r26
	push r26
;     292 #endasm
;     293 
;     294 	status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,192
;     295 	data=UDR0;
	LDS  R16,198
;     296 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     297 		com1_rx_data = data;
	MOV  R3,R16
;     298 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R2,R30
;     299 	}
;     300 
;     301 #asm
_0x3:
;     302 	pop  r26
	pop  r26
;     303 	out  sreg,r26
	out  sreg,r26
;     304 	pop  r31
	pop  r31
;     305 	pop  r30
	pop  r30
;     306 	pop  r27
	pop  r27
;     307 	pop  r26
	pop  r26
;     308 #endasm
;     309 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     310 #pragma savereg+
;     311 
;     312 
;     313 // ============================== COM2  ͷƮ ===========================
;     314 // [μ] void
;     315 // ----------------------------------------------------------------------------
;     316 #pragma savereg-
;     317 interrupt [USART1_RXC] void uart1_rx_isr(void)
;     318 {
_uart1_rx_isr:
;     319 char status,data;
;     320 #asm
;     321 	push r26
	push r26
;     322 	push r27
	push r27
;     323 	push r30
	push r30
;     324 	push r31
	push r31
;     325 	in   r26,sreg
	in   r26,sreg
;     326 	push r26
	push r26
;     327 #endasm
;     328 
;     329 	status=UCSR1A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,200
;     330 	data=UDR1;
	LDS  R16,206
;     331 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x4
;     332 		com2_rx_data = data;
	MOV  R5,R16
;     333 		com2_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     334 	}
;     335 
;     336 #asm
_0x4:
;     337 	pop  r26
	pop  r26
;     338 	out  sreg,r26
	out  sreg,r26
;     339 	pop  r31
	pop  r31
;     340 	pop  r30
	pop  r30
;     341 	pop  r27
	pop  r27
;     342 	pop  r26
	pop  r26
;     343 #endasm
;     344 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     345 #pragma savereg+
;     346 
;     347 // ============================== COM3  ͷƮ ===========================
;     348 // [μ] void
;     349 // ----------------------------------------------------------------------------
;     350 #pragma savereg-
;     351 interrupt [USART2_RXC] void uart2_rx_isr(void)
;     352 {
_uart2_rx_isr:
;     353 char status,data;
;     354 #asm
;     355 	push r26
	push r26
;     356 	push r27
	push r27
;     357 	push r30
	push r30
;     358 	push r31
	push r31
;     359 	in   r26,sreg
	in   r26,sreg
;     360 	push r26
	push r26
;     361 #endasm
;     362 
;     363 	status=UCSR2A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,208
;     364 	data=UDR2;
	LDS  R16,214
;     365 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x5
;     366 		com3_rx_data = data;
	MOV  R7,R16
;     367 		com3_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R6,R30
;     368 	}
;     369 
;     370 #asm
_0x5:
;     371 	pop  r26
	pop  r26
;     372 	out  sreg,r26
	out  sreg,r26
;     373 	pop  r31
	pop  r31
;     374 	pop  r30
	pop  r30
;     375 	pop  r27
	pop  r27
;     376 	pop  r26
	pop  r26
;     377 #endasm
;     378 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     379 #pragma savereg+
;     380 
;     381 // ============================== COM4  ͷƮ ===========================
;     382 // [μ] void
;     383 // ----------------------------------------------------------------------------
;     384 #pragma savereg-
;     385 interrupt [USART3_RXC] void uart3_rx_isr(void)
;     386 {
_uart3_rx_isr:
;     387 char status,data;
;     388 #asm
;     389 	push r26
	push r26
;     390 	push r27
	push r27
;     391 	push r30
	push r30
;     392 	push r31
	push r31
;     393 	in   r26,sreg
	in   r26,sreg
;     394 	push r26
	push r26
;     395 #endasm
;     396 
;     397 	status=UCSR3A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	LDS  R17,304
;     398 	data=UDR3;
	LDS  R16,310
;     399 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x6
;     400 		com4_rx_data = data;
	MOV  R9,R16
;     401 		com4_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R8,R30
;     402 	}
;     403 
;     404 #asm
_0x6:
;     405 	pop  r26
	pop  r26
;     406 	out  sreg,r26
	out  sreg,r26
;     407 	pop  r31
	pop  r31
;     408 	pop  r30
	pop  r30
;     409 	pop  r27
	pop  r27
;     410 	pop  r26
	pop  r26
;     411 #endasm
;     412 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     413 #pragma savereg+
;     414 
;     415 // ========================== TIMER0 overflow ͷƮ ========================
;     416 // [μ] void
;     417 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     418 // ----------------------------------------------------------------------------
;     419 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     420 {
_timer0_ovf_isr:
	CALL SUBOPT_0x9
;     421 	TCNT0 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	OUT  0x26,R30
;     422 	timer0_cnt++;						// Ÿ̸0 ī
	MOVW R30,R10
	ADIW R30,1
	MOVW R10,R30
;     423 }
	CALL SUBOPT_0xA
	RETI
;     424 
;     425 // ========================== TIMER1 overflow ͷƮ ========================
;     426 // [μ] void
;     427 // [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     428 // ----------------------------------------------------------------------------
;     429 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     430 {
_timer1_ovf_isr:
	CALL SUBOPT_0x9
;     431 	TCNT1H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xB
;     432 	TCNT1L=0x3b;
;     433 	timer1_cnt++;						// Ÿ̸1 ī
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
;     434 }
	CALL SUBOPT_0xA
	RETI
;     435 
;     436 // ========================== TIMER2 overflow ͷƮ ========================
;     437 // [μ] void
;     438 // [] 16,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     439 // ----------------------------------------------------------------------------
;     440 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;     441 {
_timer2_ovf_isr:
	CALL SUBOPT_0x9
;     442 	TCNT2 = 99;						// 255-156 = 100
	LDI  R30,LOW(99)
	STS  178,R30
;     443 	timer2_cnt++;						// Ÿ̸2 ī
	LDS  R30,_timer2_cnt
	LDS  R31,_timer2_cnt+1
	ADIW R30,1
	STS  _timer2_cnt,R30
	STS  _timer2_cnt+1,R31
;     444 }
	CALL SUBOPT_0xA
	RETI
;     445 
;     446 // ========================== TIMER3 overflow ͷƮ ========================
;     447 // [μ] void
;     448 // [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     449 // ----------------------------------------------------------------------------
;     450 interrupt [TIM3_OVF] void timer3_ovf_isr(void)
;     451 {
_timer3_ovf_isr:
	CALL SUBOPT_0x9
;     452 	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xC
;     453 	TCNT3L=0x3b;
;     454 	timer3_cnt++;						// Ÿ̸3 ī
	LDS  R30,_timer3_cnt
	LDS  R31,_timer3_cnt+1
	ADIW R30,1
	STS  _timer3_cnt,R30
	STS  _timer3_cnt+1,R31
;     455 }
	CALL SUBOPT_0xA
	RETI
;     456 
;     457 // ========================== TIMER4 overflow ͷƮ ========================
;     458 // [μ] void
;     459 // [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     460 // ----------------------------------------------------------------------------
;     461 interrupt [TIM4_OVF] void timer4_ovf_isr(void)
;     462 {
_timer4_ovf_isr:
	CALL SUBOPT_0x9
;     463 	TCNT4H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xD
;     464 	TCNT4L=0x3b;
;     465 	timer4_cnt++;						// Ÿ̸4 ī
	LDS  R30,_timer4_cnt
	LDS  R31,_timer4_cnt+1
	ADIW R30,1
	STS  _timer4_cnt,R30
	STS  _timer4_cnt+1,R31
;     466 }
	CALL SUBOPT_0xA
	RETI
;     467 
;     468 // ========================== TIMER5 overflow ͷƮ ========================
;     469 // [μ] void
;     470 // [] 16,000,000 / 64 / 2500 =  1 / 100.0 = 10ms
;     471 // ----------------------------------------------------------------------------
;     472 interrupt [TIM5_OVF] void timer5_ovf_isr(void)
;     473 {
_timer5_ovf_isr:
	CALL SUBOPT_0x9
;     474 	TCNT5H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xE
;     475 	TCNT5L=0x3b;
;     476 	timer5_cnt++;						// Ÿ̸5 ī
	LDS  R30,_timer5_cnt
	LDS  R31,_timer5_cnt+1
	ADIW R30,1
	STS  _timer5_cnt,R30
	STS  _timer5_cnt+1,R31
;     477 }
	CALL SUBOPT_0xA
	RETI
;     478 
;     479 // ========================== ܺ INT0 ͷƮ ==============================
;     480 // [μ] void
;     481 // ----------------------------------------------------------------------------
;     482 interrupt [INT0] void ext_int0_isr(void)
;     483 {
_ext_int0_isr:
	CALL SUBOPT_0xF
;     484 	exint0_flg = 1;						// EXINT0 ÷ ON
	STS  _exint0_flg,R30
	STS  _exint0_flg+1,R31
;     485 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     486 
;     487 // ========================== ܺ INT1 ͷƮ ==============================
;     488 // [μ] void
;     489 // ----------------------------------------------------------------------------
;     490 interrupt [INT1] void ext_int1_isr(void)
;     491 {
_ext_int1_isr:
	CALL SUBOPT_0xF
;     492 	exint1_flg = 1;						// EXINT1 ÷ ON
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R31
;     493 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     494 
;     495 // ========================== ܺ INT2 ͷƮ ==============================
;     496 // [μ] void
;     497 // ----------------------------------------------------------------------------
;     498 interrupt [INT2] void ext_int2_isr(void)
;     499 {
_ext_int2_isr:
	CALL SUBOPT_0xF
;     500 	exint2_flg = 1;						// EXINT2 ÷ ON
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R31
;     501 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     502 
;     503 // ========================== ܺ INT3 ͷƮ ==============================
;     504 // [μ] void
;     505 // ----------------------------------------------------------------------------
;     506 interrupt [INT3] void ext_int3_isr(void)
;     507 {
_ext_int3_isr:
	CALL SUBOPT_0xF
;     508 	exint3_flg = 1;						// EXINT3 ÷ ON
	STS  _exint3_flg,R30
	STS  _exint3_flg+1,R31
;     509 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     510 
;     511 // ========================== ܺ INT4 ͷƮ ==============================
;     512 // [μ] void
;     513 // ----------------------------------------------------------------------------
;     514 interrupt [INT4] void ext_int4_isr(void)
;     515 {
_ext_int4_isr:
	CALL SUBOPT_0xF
;     516 	exint4_flg = 1;						// EXINT4 ÷ ON
	STS  _exint4_flg,R30
	STS  _exint4_flg+1,R31
;     517 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     518 
;     519 // ========================== ܺ INT5 ͷƮ ==============================
;     520 // [μ] void
;     521 // ----------------------------------------------------------------------------
;     522 interrupt [INT5] void ext_int5_isr(void)
;     523 {
_ext_int5_isr:
	CALL SUBOPT_0xF
;     524 	exint5_flg = 1;						// EXINT5 ÷ ON
	STS  _exint5_flg,R30
	STS  _exint5_flg+1,R31
;     525 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     526 
;     527 // ========================== ܺ INT6 ͷƮ ==============================
;     528 // [μ] void
;     529 // ----------------------------------------------------------------------------
;     530 interrupt [INT6] void ext_int6_isr(void)
;     531 {
_ext_int6_isr:
	CALL SUBOPT_0xF
;     532 	exint6_flg = 1;						// EXINT6 ÷ ON
	STS  _exint6_flg,R30
	STS  _exint6_flg+1,R31
;     533 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     534 
;     535 // ========================== ܺ INT7 ͷƮ ==============================
;     536 // [μ] void
;     537 // ----------------------------------------------------------------------------
;     538 interrupt [INT7] void ext_int7_isr(void)
;     539 {
_ext_int7_isr:
	CALL SUBOPT_0xF
;     540 	exint7_flg = 1;						// EXINT7 ÷ ON
	STS  _exint7_flg,R30
	STS  _exint7_flg+1,R31
;     541 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     542 
;     543 // =============================== ADC ͷƮ ===============================
;     544 // [μ] void
;     545 // ----------------------------------------------------------------------------
;     546 interrupt [ADC_INT] void adc_isr(void)
;     547 {
_adc_isr:
	ST   -Y,R30
	ST   -Y,R31
;     548 	adc_int_data = ADCW;					// ADC
	LDS  R30,120
	LDS  R31,120+1
	STS  _adc_int_data,R30
	STS  _adc_int_data+1,R31
;     549 	adc_int_flg = 1;					// ADC Ϸ ÷ 
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R31
;     550 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     551 
;     552 // Լ 
;     553 void main_menu_disp(void);					//  ޴ ǥ
;     554 void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
;     555 void timer0_test(void);						// TIMER0 TEST
;     556 void timer1_test(void);						// TIMER1 TEST
;     557 void timer2_test(void);						// TIMER2 TEST
;     558 void timer3_test(void);						// TIMER3 TEST
;     559 void timer4_test(void);						// TIMER4 TEST
;     560 void timer5_test(void);						// TIMER5 TEST
;     561 void exint_test(void);						// EXINT0,1 TEST
;     562 
;     563 void ad_polling_test(void);					// A/D   TEST
;     564 unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
;     565 void ad_interrupt_test(void);					// A/D ͷƮ  TEST
;     566 void ad_start(unsigned char adc_input);				// AD  (ͷƮ )
;     567 
;     568 void eeprom_test(void);						// EEPROM TEST
;     569 void EEPROM_write(int addr,unsigned char data);			// EEPROM  
;     570 unsigned char EEPROM_read(int addr);				// EEPROM  
;     571 
;     572 void sram_test(void);						// SRAM TEST
;     573 
;     574 void com2_test(void);						// COM2 TEST
;     575 void putchar1(char c);						// COM2 1Ʈ ۽
;     576 void com3_test(void);						// COM3 TEST
;     577 void putchar2(char c);						// COM3 1Ʈ ۽
;     578 void com4_test(void);						// COM4 TEST
;     579 void putchar3(char c);						// COM4 1Ʈ ۽
;     580 
;     581 void urx_string(char buff[]);					// Ʈ 
;     582 long atoh(char buff[]);						// ASCII TO HEX 
;     583 
;     584 //  
;     585 
;     586 // ===============================  α׷ ==============================
;     587 // [μ]: void
;     588 // ---------------------------------------------------------------------------
;     589 void main(void)
;     590 {
_main:
;     591 	cpu_setup();						// cpuʱȭ
	CALL _cpu_setup
;     592 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     593 	while(1){						// Place your code here
_0x7:
;     594 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BRNE PC+3
	JMP _0xA
;     595 			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
	LDI  R30,LOW(49)
	CP   R30,R3
	BRNE _0xB
	RCALL _cpu_ioport_output
;     596 			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
	RJMP _0xC
_0xB:
	LDI  R30,LOW(50)
	CP   R30,R3
	BRNE _0xD
	RCALL _timer0_test
;     597 			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
	RJMP _0xE
_0xD:
	LDI  R30,LOW(51)
	CP   R30,R3
	BRNE _0xF
	RCALL _timer1_test
;     598 			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
	RJMP _0x10
_0xF:
	LDI  R30,LOW(52)
	CP   R30,R3
	BRNE _0x11
	RCALL _timer2_test
;     599 			else if(com1_rx_data == '5') timer3_test(); // TIMER3 TEST
	RJMP _0x12
_0x11:
	LDI  R30,LOW(53)
	CP   R30,R3
	BRNE _0x13
	RCALL _timer3_test
;     600 			else if(com1_rx_data == '6') timer4_test(); // TIMER4 TEST
	RJMP _0x14
_0x13:
	LDI  R30,LOW(54)
	CP   R30,R3
	BRNE _0x15
	RCALL _timer4_test
;     601 			else if(com1_rx_data == '7') timer5_test(); // TIMER5 TEST
	RJMP _0x16
_0x15:
	LDI  R30,LOW(55)
	CP   R30,R3
	BRNE _0x17
	RCALL _timer5_test
;     602 			else if(com1_rx_data == '8') exint_test();  // EXINT0,1 TEST
	RJMP _0x18
_0x17:
	LDI  R30,LOW(56)
	CP   R30,R3
	BRNE _0x19
	RCALL _exint_test
;     603 			else if(com1_rx_data == '9') ad_polling_test();// A/D POLLING TEST
	RJMP _0x1A
_0x19:
	LDI  R30,LOW(57)
	CP   R30,R3
	BRNE _0x1B
	RCALL _ad_polling_test
;     604 			else if(com1_rx_data == 'a') ad_interrupt_test(); // A/D POLLING TEST
	RJMP _0x1C
_0x1B:
	LDI  R30,LOW(97)
	CP   R30,R3
	BRNE _0x1D
	RCALL _ad_interrupt_test
;     605 			else if(com1_rx_data == 'b') eeprom_test(); // EEPROM TEST
	RJMP _0x1E
_0x1D:
	LDI  R30,LOW(98)
	CP   R30,R3
	BRNE _0x1F
	RCALL _eeprom_test
;     606 			else if(com1_rx_data == 'c') sram_test();// SRAM TEST
	RJMP _0x20
_0x1F:
	LDI  R30,LOW(99)
	CP   R30,R3
	BRNE _0x21
	RCALL _sram_test
;     607 			else if(com1_rx_data == 'd') com2_test();// COM2 TEST
	RJMP _0x22
_0x21:
	LDI  R30,LOW(100)
	CP   R30,R3
	BRNE _0x23
	CALL _com2_test
;     608 			else if(com1_rx_data == 'e') com3_test();// COM3 TEST
	RJMP _0x24
_0x23:
	LDI  R30,LOW(101)
	CP   R30,R3
	BRNE _0x25
	CALL _com3_test
;     609 			else if(com1_rx_data == 'f') com4_test();// COM4 TEST
	RJMP _0x26
_0x25:
	LDI  R30,LOW(102)
	CP   R30,R3
	BRNE _0x27
	CALL _com4_test
;     610 			else putchar(com1_rx_data);
	RJMP _0x28
_0x27:
	ST   -Y,R3
	CALL _putchar
;     611 			com1_rx_eflg = 0;
_0x28:
_0x26:
_0x24:
_0x22:
_0x20:
_0x1E:
_0x1C:
_0x1A:
_0x18:
_0x16:
_0x14:
_0x12:
_0x10:
_0xE:
_0xC:
	CLR  R2
;     612 		}
;     613 	}
_0xA:
	RJMP _0x7
;     614 }
_0x29:
	RJMP _0x29
;     615 
;     616 // =====================================  ޴ ǥ =======================
;     617 // [μ]: void
;     618 // ---------------------------------------------------------------------------
;     619 void main_menu_disp(void)
;     620 {
_main_menu_disp:
;     621 	printf("\r\n");
	CALL SUBOPT_0x10
;     622 	printf("=================== MAIN MENU ==================\r\n");
	__POINTW1FN _0,3
	CALL SUBOPT_0x11
;     623 	printf("- 1  : CPU I/O PORT TEST                        \r\n");
	__POINTW1FN _0,54
	CALL SUBOPT_0x11
;     624 	printf("- 2  : TIMER0 TEST                              \r\n");
	__POINTW1FN _0,105
	CALL SUBOPT_0x11
;     625 	printf("- 3  : TIMER1 TEST                              \r\n");
	__POINTW1FN _0,156
	CALL SUBOPT_0x11
;     626 	printf("- 4  : TIMER2 TEST                              \r\n");
	__POINTW1FN _0,207
	CALL SUBOPT_0x11
;     627 	printf("- 5  : TIMER3 TEST                              \r\n");
	__POINTW1FN _0,258
	CALL SUBOPT_0x11
;     628 	printf("- 6  : TIMER4 TEST                              \r\n");
	__POINTW1FN _0,309
	CALL SUBOPT_0x11
;     629 	printf("- 7  : TIMER5 TEST                              \r\n");
	__POINTW1FN _0,360
	CALL SUBOPT_0x11
;     630 	printf("- 8  : EXINT0,1,2,3,4,5,6,7 TEST                \r\n");
	__POINTW1FN _0,411
	CALL SUBOPT_0x11
;     631 	printf("- 9  : A/D POLLING   TEST                       \r\n");
	__POINTW1FN _0,462
	CALL SUBOPT_0x11
;     632 	printf("- a  : A/D INTERRUPT TEST                       \r\n");
	__POINTW1FN _0,513
	CALL SUBOPT_0x11
;     633 	printf("- b  : EEPROM TEST                              \r\n");
	__POINTW1FN _0,564
	CALL SUBOPT_0x11
;     634 	printf("- c  : SRAM   TEST                              \r\n");
	__POINTW1FN _0,615
	CALL SUBOPT_0x11
;     635 	printf("- d  : COM2   TEST                              \r\n");
	__POINTW1FN _0,666
	CALL SUBOPT_0x11
;     636 	printf("- e  : COM3   TEST                              \r\n");
	__POINTW1FN _0,717
	CALL SUBOPT_0x11
;     637 	printf("- f  : COM4   TEST                              \r\n");
	__POINTW1FN _0,768
	CALL SUBOPT_0x11
;     638 	printf("----------------- CPUPLAZA ---------------------\r\n");
	__POINTW1FN _0,819
	CALL SUBOPT_0x11
;     639 }
	RET
;     640 
;     641 // ============================== CPU_IO TEST =================================
;     642 // [μ]: void
;     643 // ----------------------------------------------------------------------------
;     644 void cpu_ioport_output(void)
;     645 {
_cpu_ioport_output:
;     646 int out_cnt,exit_flg = 0;
;     647 
;     648 	printf("================ CPU I/O PORT TEST ==============\r\n");
	CALL SUBOPT_0x12
;	out_cnt -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,870
	CALL SUBOPT_0x11
;     649 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;     650 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;     651 // CPU PORT   
;     652 // PORTA[0..7] : OUT
;     653 	PORTA=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x2,R30
;     654 	DDRA=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x1,R30
;     655 // CPU PORT   
;     656 // PORTB[0..7] : OUT
;     657 	PORTB=0xff;						// Ʈ  reg
	OUT  0x5,R30
;     658 	DDRB=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x4,R30
;     659 // PORTC[0..5] : OUT
;     660 	PORTC=0xff;						// Ʈ  reg
	OUT  0x8,R30
;     661 	DDRC=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x7,R30
;     662 // PORTD[0..7] : OUT
;     663 	PORTD=0xff;						// Ʈ  reg
	OUT  0xB,R30
;     664 	DDRD=0xff;						// Ʈ  reg(0Է,1)
	OUT  0xA,R30
;     665 // PORTE[2..7] : OUT
;     666 	PORTE=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0xE,R30
;     667 	DDRE=0xfc;						// Ʈ  reg(0Է,1)
	OUT  0xD,R30
;     668 // PORTF[0..7] : OUT
;     669 	PORTF=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     670 	DDRF=0xff;						// Ʈ  reg(0Է,1)
	OUT  0x10,R30
;     671 // PORTG[0..5] : OUT
;     672 	PORTG=0x27;						// Ʈ  reg
	LDI  R30,LOW(39)
	OUT  0x14,R30
;     673 	DDRG=0x27;						// Ʈ  reg(0Է,1)
	OUT  0x13,R30
;     674 // PORTJ[0..7] : OUT
;     675 	PORTJ=0xff;						// Ʈ  reg
	LDI  R30,LOW(255)
	STS  261,R30
;     676 	DDRJ=0x0ff;						// Ʈ  reg(0Է,1)
	STS  260,R30
;     677 // PORTK[0..7] : OUT
;     678         PORTK=0xff;	                			// Ʈ  reg
	STS  264,R30
;     679         DDRK=0xff;						// Ʈ  reg(0Է,1)
	STS  263,R30
;     680 // PORTL[0..2] : OUT
;     681 	PORTL=0xff;						// Ʈ  reg
	STS  267,R30
;     682 	DDRL=0xff;						// Ʈ  reg(0Է,1)
	STS  266,R30
;     683 
;     684 // LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
;     685 // Timer/Counter0 (Overflow)
;     686         TCCR0A=0x00;
	CALL SUBOPT_0x15
;     687 	TCCR0B = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
;     688 	TCNT0 = 99;						// 255-156 = 99
;     689 	OCR0A = 0x00;
;     690 	OCR0B = 0x00;
;     691 	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡
;     692 
;     693 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     694 	out_cnt = 0;
	__GETWRN 16,17,0
;     695 	com1_rx_eflg = 0;
	CLR  R2
;     696 	while(exit_flg == 0){
_0x2A:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x2C
;     697 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x2D
;     698 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x2E
	__GETWRN 18,19,1
;     699 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x2F
_0x2E:
	ST   -Y,R3
	CALL _putchar
;     700 			com1_rx_eflg = 0;
_0x2F:
	CLR  R2
;     701 		}
;     702 		if(timer0_cnt >= 50){				// 500ms  
_0x2D:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R10,R30
	CPC  R11,R31
	BRGE PC+3
	JMP _0x30
;     703 			if(out_cnt >= 0 && out_cnt < 8) PORTA = ~(1 << out_cnt);// PORTA (ش Ʈ 0)
	SUBI R16,0
	SBCI R17,0
	BRLT _0x32
	__CPWRN 16,17,8
	BRLT _0x33
_0x32:
	RJMP _0x31
_0x33:
	MOVW R30,R16
	CALL SUBOPT_0x16
	OUT  0x2,R30
;     704 			else if(out_cnt >= 8 && out_cnt < 16){	// PORTB 
	RJMP _0x34
_0x31:
	__CPWRN 16,17,8
	BRLT _0x36
	__CPWRN 16,17,16
	BRLT _0x37
_0x36:
	RJMP _0x35
_0x37:
;     705 				if(out_cnt == 8) PORTA = 0xff;	// PORTA CLEAR
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x38
	LDI  R30,LOW(255)
	OUT  0x2,R30
;     706 				PORTB = ~(1 << (out_cnt-8));	// PORTB (ش Ʈ 0)
_0x38:
	MOVW R30,R16
	SBIW R30,8
	CALL SUBOPT_0x16
	OUT  0x5,R30
;     707 			}
;     708 			else if(out_cnt >= 16 && out_cnt < 24){	// PORT C 
	RJMP _0x39
_0x35:
	__CPWRN 16,17,16
	BRLT _0x3B
	__CPWRN 16,17,24
	BRLT _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
;     709 				if(out_cnt == 16) PORTB = 0xff;	// PORTB CLEAR
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x3D
	LDI  R30,LOW(255)
	OUT  0x5,R30
;     710 				PORTC = ~(1 << (out_cnt-16));	// PORTC (ش Ʈ 0)
_0x3D:
	MOVW R30,R16
	SBIW R30,16
	CALL SUBOPT_0x16
	OUT  0x8,R30
;     711 			}
;     712 			else if(out_cnt >= 24 && out_cnt < 32){	// PORTD 
	RJMP _0x3E
_0x3A:
	__CPWRN 16,17,24
	BRLT _0x40
	__CPWRN 16,17,32
	BRLT _0x41
_0x40:
	RJMP _0x3F
_0x41:
;     713 				if(out_cnt == 24) PORTC = 0xff;	// PORTC CLEAR
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x42
	LDI  R30,LOW(255)
	OUT  0x8,R30
;     714 				PORTD = ~(1 << (out_cnt-24));	// PORTD (ش Ʈ 0)
_0x42:
	MOVW R30,R16
	SBIW R30,24
	CALL SUBOPT_0x16
	OUT  0xB,R30
;     715 			}
;     716 			else if(out_cnt >= 32 && out_cnt < 38){	// PORTE 
	RJMP _0x43
_0x3F:
	__CPWRN 16,17,32
	BRLT _0x45
	__CPWRN 16,17,38
	BRLT _0x46
_0x45:
	RJMP _0x44
_0x46:
;     717 				if(out_cnt == 32) PORTD = 0xff;	// PORTD CLEAR
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x47
	LDI  R30,LOW(255)
	OUT  0xB,R30
;     718 				PORTE = ~(4 << (out_cnt-32));	// PORTE (ش Ʈ 0)
_0x47:
	MOVW R30,R16
	SBIW R30,32
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	CALL __LSLW12
	COM  R30
	COM  R31
	OUT  0xE,R30
;     719 			}
;     720 			else if(out_cnt >= 38 && out_cnt < 46){	// PORTF 
	RJMP _0x48
_0x44:
	__CPWRN 16,17,38
	BRLT _0x4A
	__CPWRN 16,17,46
	BRLT _0x4B
_0x4A:
	RJMP _0x49
_0x4B:
;     721 				if(out_cnt == 38) PORTE = 0xfc;	// PORTE CLEAR
	LDI  R30,LOW(38)
	LDI  R31,HIGH(38)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x4C
	LDI  R30,LOW(252)
	OUT  0xE,R30
;     722 				PORTF = ~(1 << (out_cnt-38));	// PORTF (ش Ʈ 0)
_0x4C:
	MOVW R30,R16
	SBIW R30,38
	CALL SUBOPT_0x16
	OUT  0x11,R30
;     723 			}
;     724 			else if(out_cnt >= 46 && out_cnt < 50){	// PORTG 
	RJMP _0x4D
_0x49:
	__CPWRN 16,17,46
	BRLT _0x4F
	__CPWRN 16,17,50
	BRLT _0x50
_0x4F:
	RJMP _0x4E
_0x50:
;     725 				if(out_cnt == 46) PORTF = 0xff;	// PORTF CLEAR
	LDI  R30,LOW(46)
	LDI  R31,HIGH(46)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x51
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     726 				if(out_cnt < 49) PORTG = ~(1 << (out_cnt-46));// PORTG (ش Ʈ 0)
_0x51:
	__CPWRN 16,17,49
	BRGE _0x52
	MOVW R30,R16
	SBIW R30,46
	CALL SUBOPT_0x16
	RJMP _0x1D0
;     727 				else PORTG = ~(1 << 5);		// PORTG (ش Ʈ 0)
_0x52:
	LDI  R30,LOW(223)
_0x1D0:
	OUT  0x14,R30
;     728 			}
;     729 			else if(out_cnt >= 50 && out_cnt < 58){	// PORTJ 
	RJMP _0x54
_0x4E:
	__CPWRN 16,17,50
	BRLT _0x56
	__CPWRN 16,17,58
	BRLT _0x57
_0x56:
	RJMP _0x55
_0x57:
;     730 				if(out_cnt == 50) PORTG = 0x27;	// PORTG CLEAR
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x58
	LDI  R30,LOW(39)
	OUT  0x14,R30
;     731 				PORTJ = ~(1 << (out_cnt-50));	// PORTJ (ش Ʈ 0)
_0x58:
	MOVW R30,R16
	SBIW R30,50
	CALL SUBOPT_0x16
	STS  261,R30
;     732 			}
;     733 			else if(out_cnt >= 58 && out_cnt < 66){	// PORTK 
	RJMP _0x59
_0x55:
	__CPWRN 16,17,58
	BRLT _0x5B
	__CPWRN 16,17,66
	BRLT _0x5C
_0x5B:
	RJMP _0x5A
_0x5C:
;     734 				if(out_cnt == 58) PORTJ = 0xff;	// PORTJ CLEAR
	LDI  R30,LOW(58)
	LDI  R31,HIGH(58)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x5D
	LDI  R30,LOW(255)
	STS  261,R30
;     735 				PORTK = ~(1 << (out_cnt-58));	// PORTK (ش Ʈ 0)
_0x5D:
	MOVW R30,R16
	SBIW R30,58
	CALL SUBOPT_0x16
	STS  264,R30
;     736 			}
;     737 			else if(out_cnt >= 66 && out_cnt < 74){	// PORTL 
	RJMP _0x5E
_0x5A:
	__CPWRN 16,17,66
	BRLT _0x60
	__CPWRN 16,17,74
	BRLT _0x61
_0x60:
	RJMP _0x5F
_0x61:
;     738 				if(out_cnt == 66) PORTK = 0xff;	// PORTK CLEAR
	LDI  R30,LOW(66)
	LDI  R31,HIGH(66)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x62
	LDI  R30,LOW(255)
	STS  264,R30
;     739 				PORTL = ~(1 << (out_cnt-66));	// PORTL (ش Ʈ 0)
_0x62:
	MOVW R30,R16
	SUBI R30,LOW(66)
	SBCI R31,HIGH(66)
	CALL SUBOPT_0x16
	STS  267,R30
;     740 			}
;     741 			out_cnt++;				//  ġ ī 
_0x5F:
_0x5E:
_0x59:
_0x54:
_0x4D:
_0x48:
_0x43:
_0x3E:
_0x39:
_0x34:
	__ADDWRN 16,17,1
;     742 			if(out_cnt >= 75) out_cnt = 0;		//  ġ ʰ ˻
	__CPWRN 16,17,75
	BRLT _0x63
	__GETWRN 16,17,0
;     743 			if(out_cnt == 0){			//  ü ʱȭ
_0x63:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x64
;     744 				PORTA = 0xff;
	LDI  R30,LOW(255)
	OUT  0x2,R30
;     745 				PORTB = 0xff;
	OUT  0x5,R30
;     746 				PORTC = 0xff;
	OUT  0x8,R30
;     747 				PORTD = 0xff;
	OUT  0xB,R30
;     748 				PORTE = 0xfc;
	LDI  R30,LOW(252)
	OUT  0xE,R30
;     749 				PORTF = 0xff;
	LDI  R30,LOW(255)
	OUT  0x11,R30
;     750 				PORTG = 0x27;
	LDI  R30,LOW(39)
	OUT  0x14,R30
;     751 				PORTJ = 0xff;
	LDI  R30,LOW(255)
	STS  261,R30
;     752 				PORTK = 0xff;
	STS  264,R30
;     753 				PORTL = 0xff;
	STS  267,R30
;     754 			}
;     755 			timer0_cnt = 0;
_0x64:
	CLR  R10
	CLR  R11
;     756 		}
;     757 	}
_0x30:
	RJMP _0x2A
_0x2C:
;     758 
;     759 // Timer/Counter0 
;     760 	TCCR0A = 0x00;
	CALL SUBOPT_0x1
;     761 	TCCR0B = 0x00;
;     762 	TCNT0  = 0x00;
;     763 	OCR0A = 0x00;
;     764 	OCR0B = 0x00;
;     765 	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 
	LDS  R30,110
	ANDI R30,0xFE
	STS  110,R30
;     766 
;     767 // CPU PORT ʱⰪ  
;     768 // PORTA
;     769 	PORTA=0x00;						// Ʈ  reg
	CALL SUBOPT_0x0
;     770 	DDRA=0x00;						// Ʈ  reg(0Է,1)
;     771 // PORTB
;     772 	PORTB=0x00;						// Ʈ  reg
;     773 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;     774 // PORTC
;     775 	PORTC=0x00;						// Ʈ  reg
;     776 	DDRC=0x00;						// Ʈ  reg(0Է,1)
;     777 // PORTD
;     778 	PORTD=0x00;						// Ʈ  reg
;     779 	DDRD=0x00;						// Ʈ  reg(0Է,1)
;     780 // PORTE
;     781 	PORTE=0x00;						// Ʈ  reg
;     782 	DDRE=0x00;						// Ʈ  reg(0Է,1)
;     783 // PORTF
;     784 	PORTF=0x00;						// Ʈ  reg
;     785 	DDRF=0x00;						// Ʈ  reg(0Է,1)
;     786 // PORTG
;     787 	PORTG=0x00;						// Ʈ  reg
;     788 	DDRG=0x00;						// Ʈ  reg(0Է,1)
;     789 // PORTJ
;     790 	PORTJ=0x00;						// Ʈ  reg
;     791 	DDRJ=0x00;						// Ʈ  reg(0Է,1)
;     792 // PORTK
;     793 	PORTK=0x00;						// Ʈ  reg
;     794 	DDRK=0x00;						// Ʈ  reg(0Է,1)
;     795 // PORTL
;     796 	PORTL=0x00;						// Ʈ  reg
;     797 	DDRL=0x00;						// Ʈ  reg(0Է,1)
;     798 
;     799 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     800 }
	RJMP _0x1CE
;     801 
;     802 // ============================== TIMER0 TEST =================================
;     803 // [μ]: void
;     804 // ----------------------------------------------------------------------------
;     805 void timer0_test(void)
;     806 {
_timer0_test:
;     807 int exit_flg = 0;
;     808 
;     809 	printf("=================== TIMER0 TEST =================\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1026
	CALL SUBOPT_0x11
;     810 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;     811 	printf("- interrupt    : TIMER0 Overfow 9.9984ms         \r\n");
	__POINTW1FN _0,1078
	CALL SUBOPT_0x11
;     812 	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	__POINTW1FN _0,1130
	CALL SUBOPT_0x11
;     813 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;     814 
;     815 // Timer/Counter0 (Overflow)
;     816 	TCCR0A = 0x00;
	CALL SUBOPT_0x15
;     817 	TCCR0B = 0x05;						// system clock,16,000,000 / 1024 = 15.625Khz
;     818 	TCNT0 = 99;						// 255-156 = 99
;     819 	OCR0A = 0x00;
;     820 	OCR0B = 0x00;
;     821 	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡
;     822 
;     823 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     824 	com1_rx_eflg = 0;
	CLR  R2
;     825 	while(exit_flg == 0){
_0x65:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x67
;     826 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x68
;     827 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x69
	__GETWRN 16,17,1
;     828 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x6A
_0x69:
	ST   -Y,R3
	RCALL _putchar
;     829 			com1_rx_eflg = 0;
_0x6A:
	CLR  R2
;     830 		}
;     831 		if(timer0_cnt >= 100){				// 999.84ms üũ
_0x68:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R10,R30
	CPC  R11,R31
	BRLT _0x6B
;     832 			printf("TIMER0 Overflow Interrupt\r\n");
	__POINTW1FN _0,1182
	CALL SUBOPT_0x11
;     833 			timer0_cnt = 0;
	CLR  R10
	CLR  R11
;     834 		}
;     835 	}
_0x6B:
	RJMP _0x65
_0x67:
;     836 
;     837 // Timer/Counter0 
;     838 	TCCR0A = 0x00;
	CALL SUBOPT_0x1
;     839 	TCCR0B = 0x00;
;     840 	TCNT0  = 0x00;
;     841 	OCR0A = 0x00;
;     842 	OCR0B = 0x00;
;     843 	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 
	LDS  R30,110
	ANDI R30,0xFE
	STS  110,R30
;     844 
;     845 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     846 }
	RJMP _0x1CF
;     847 
;     848 // ============================== TIMER1 TEST =================================
;     849 // [μ]: void
;     850 // ----------------------------------------------------------------------------
;     851 void timer1_test(void)
;     852 {
_timer1_test:
;     853 int exit_flg = 0;
;     854 
;     855 	printf("=================== TIMER1 TEST =================\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1210
	CALL SUBOPT_0x11
;     856 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;     857 	printf("- interrupt    : TIMER1 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,1262
	CALL SUBOPT_0x11
;     858 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	CALL SUBOPT_0x18
;     859 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;     860 
;     861 // Timer/Counter1 (Overflow)
;     862 	TCCR1A=0x00;
	LDI  R30,LOW(0)
	STS  128,R30
;     863 	TCCR1B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	STS  129,R30
;     864 	TCNT1H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xB
;     865 	TCNT1L=0x3b;
;     866 	ICR1H=0x00;
	LDI  R30,LOW(0)
	STS  135,R30
;     867 	ICR1L=0x00;
	STS  134,R30
;     868 	OCR1AH=0x00;
	STS  137,R30
;     869 	OCR1AL=0x00;
	STS  136,R30
;     870 	OCR1BH=0x00;
	STS  139,R30
;     871 	OCR1BL=0x00;
	STS  138,R30
;     872 	OCR1CH=0x00;
	STS  141,R30
;     873 	OCR1CL=0x00;
	STS  140,R30
;     874 	TIMSK1 |= 0x01;						// TIMER1 ͷƮ 㰡
	LDS  R30,111
	ORI  R30,1
	STS  111,R30
;     875 
;     876 	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	CLR  R12
	CLR  R13
;     877 	com1_rx_eflg = 0;
	CLR  R2
;     878 	while(exit_flg == 0){					// COM1  ˻
_0x6C:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x6E
;     879 		if(com1_rx_eflg){
	TST  R2
	BREQ _0x6F
;     880 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x70
	__GETWRN 16,17,1
;     881 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x71
_0x70:
	ST   -Y,R3
	RCALL _putchar
;     882 			com1_rx_eflg = 0;
_0x71:
	CLR  R2
;     883 		}
;     884 		if(timer1_cnt >= 100){				// 1s üũ
_0x6F:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R12,R30
	CPC  R13,R31
	BRLT _0x72
;     885 			printf("TIMER1 Overflow Interrupt\r\n");
	__POINTW1FN _0,1366
	CALL SUBOPT_0x11
;     886 			timer1_cnt = 0;
	CLR  R12
	CLR  R13
;     887 		}
;     888 	}
_0x72:
	RJMP _0x6C
_0x6E:
;     889 
;     890 // Timer/Counter1 
;     891 	TCCR1A=0x00;
	CALL SUBOPT_0x2
;     892 	TCCR1B=0x00;
;     893 	TCNT1H=0x00;
;     894 	TCNT1L=0x00;
;     895 	ICR1H=0x00;
;     896 	ICR1L=0x00;
;     897 	OCR1AH=0x00;
;     898 	OCR1AL=0x00;
;     899 	OCR1BH=0x00;
;     900 	OCR1BL=0x00;
;     901 	OCR1CH=0x00;
;     902 	OCR1CL=0x00;
;     903 	TIMSK1 &= 0xfe;						// TIMER1 ͷƮ 
	LDS  R30,111
	ANDI R30,0xFE
	STS  111,R30
;     904 
;     905 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     906 }
	RJMP _0x1CF
;     907 
;     908 // ============================== TIMER2 TEST =================================
;     909 // [μ]: void
;     910 // ----------------------------------------------------------------------------
;     911 void timer2_test(void)
;     912 {
_timer2_test:
;     913 int exit_flg = 0;
;     914 
;     915 	printf("=================== TIMER2 TEST =================\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1394
	CALL SUBOPT_0x11
;     916 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;     917 	printf("- interrupt    : TIMER2 Overfow 9.9984ms         \r\n");
	__POINTW1FN _0,1446
	CALL SUBOPT_0x11
;     918 	printf("- message disp : 9.9984ms * 100 = 999.84ms       \r\n");
	__POINTW1FN _0,1130
	CALL SUBOPT_0x11
;     919 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;     920 
;     921 // Timer/Counter2 (Overflow)
;     922 	ASSR=0x00;
	CALL SUBOPT_0x3
;     923 	TCCR2A=0x00;
;     924 	TCCR2B=0x07;						// system clock,16,000,000 / 1024 = 15.625Khz
	LDI  R30,LOW(7)
	STS  177,R30
;     925 	TCNT2 = 99;						// 255-156 = 99
	LDI  R30,LOW(99)
	STS  178,R30
;     926 	OCR2A=0x00;
	LDI  R30,LOW(0)
	STS  179,R30
;     927 	OCR2B=0x00;
	STS  180,R30
;     928 	TIMSK2 |= 0x01;						// TIMER2 ͷƮ 㰡
	LDS  R30,112
	ORI  R30,1
	STS  112,R30
;     929 
;     930 	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	LDI  R30,0
	STS  _timer2_cnt,R30
	STS  _timer2_cnt+1,R30
;     931 	com1_rx_eflg = 0;
	CLR  R2
;     932 	while(exit_flg == 0){
_0x73:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x75
;     933 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x76
;     934 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x77
	__GETWRN 16,17,1
;     935 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x78
_0x77:
	ST   -Y,R3
	RCALL _putchar
;     936 			com1_rx_eflg = 0;
_0x78:
	CLR  R2
;     937 		}
;     938 		if(timer2_cnt >= 100){				// 999.84ms üũ
_0x76:
	LDS  R26,_timer2_cnt
	LDS  R27,_timer2_cnt+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x79
;     939 			printf("TIMER2 Overflow Interrupt\r\n");
	__POINTW1FN _0,1498
	CALL SUBOPT_0x11
;     940 			timer2_cnt = 0;
	LDI  R30,0
	STS  _timer2_cnt,R30
	STS  _timer2_cnt+1,R30
;     941 		}
;     942 	}
_0x79:
	RJMP _0x73
_0x75:
;     943 
;     944 // Timer/Counter2 
;     945 	ASSR=0x00;
	CALL SUBOPT_0x3
;     946 	TCCR2A=0x00;
;     947 	TCCR2B=0x00;
	CALL SUBOPT_0x4
;     948 	TCNT2=0x00;
;     949 	OCR2A=0x00;
;     950 	OCR2B=0x00;
;     951 	TIMSK2 &= 0xfe;						// TIMER2 ͷƮ 
	LDS  R30,112
	ANDI R30,0xFE
	STS  112,R30
;     952 
;     953 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;     954 }
	RJMP _0x1CF
;     955 
;     956 // ============================== TIMER3 TEST =================================
;     957 // [μ]: void
;     958 // ----------------------------------------------------------------------------
;     959 void timer3_test(void)
;     960 {
_timer3_test:
;     961 int exit_flg = 0;
;     962 
;     963 	printf("=================== TIMER3 TEST =================\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1526
	CALL SUBOPT_0x11
;     964 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;     965 	printf("- interrupt    : TIMER3 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,1578
	CALL SUBOPT_0x11
;     966 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	CALL SUBOPT_0x18
;     967 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;     968 
;     969 // Timer/Counter3 (Overflow)
;     970 	TCCR3A=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;     971 	TCCR3B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	STS  145,R30
;     972 	TCNT3H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xC
;     973 	TCNT3L=0x3b;
;     974 	ICR3H=0x00;
	LDI  R30,LOW(0)
	STS  151,R30
;     975 	ICR3L=0x00;
	STS  150,R30
;     976 	OCR3AH=0x00;
	STS  153,R30
;     977 	OCR3AL=0x00;
	STS  152,R30
;     978 	OCR3BH=0x00;
	STS  155,R30
;     979 	OCR3BL=0x00;
	STS  154,R30
;     980 	OCR3CH=0x00;
	STS  157,R30
;     981 	OCR3CL=0x00;
	STS  156,R30
;     982 	TIMSK3 |= 0x01;						// TIMER3 ͷƮ 㰡
	LDS  R30,113
	ORI  R30,1
	STS  113,R30
;     983 
;     984 	timer3_cnt = 0;						// TIMER3 ͷƮ ī Ŭ
	LDI  R30,0
	STS  _timer3_cnt,R30
	STS  _timer3_cnt+1,R30
;     985 	com1_rx_eflg = 0;
	CLR  R2
;     986 	while(exit_flg == 0){					// COM1  ˻
_0x7A:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x7C
;     987 		if(com1_rx_eflg){
	TST  R2
	BREQ _0x7D
;     988 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x7E
	__GETWRN 16,17,1
;     989 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x7F
_0x7E:
	ST   -Y,R3
	RCALL _putchar
;     990 			com1_rx_eflg = 0;
_0x7F:
	CLR  R2
;     991 		}
;     992 		if(timer3_cnt >= 100){				// 1s üũ
_0x7D:
	LDS  R26,_timer3_cnt
	LDS  R27,_timer3_cnt+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x80
;     993 			printf("TIMER3 Overflow Interrupt\r\n");
	__POINTW1FN _0,1630
	CALL SUBOPT_0x11
;     994 			timer3_cnt = 0;
	LDI  R30,0
	STS  _timer3_cnt,R30
	STS  _timer3_cnt+1,R30
;     995 		}
;     996 	}
_0x80:
	RJMP _0x7A
_0x7C:
;     997 
;     998 // Timer/Counter3 
;     999 	TCCR3A=0x00;
	CALL SUBOPT_0x5
;    1000 	TCCR3B=0x00;
;    1001 	TCNT3H=0x00;
;    1002 	TCNT3L=0x00;
;    1003 	ICR3H=0x00;
;    1004 	ICR3L=0x00;
;    1005 	OCR3AH=0x00;
;    1006 	OCR3AL=0x00;
;    1007 	OCR3BH=0x00;
;    1008 	OCR3BL=0x00;
;    1009 	OCR3CH=0x00;
;    1010 	OCR3CL=0x00;
;    1011 	TIMSK3 &= 0xfe;						// TIMER3 ͷƮ 
	LDS  R30,113
	ANDI R30,0xFE
	STS  113,R30
;    1012 
;    1013 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;    1014 }
	RJMP _0x1CF
;    1015 
;    1016 // ============================== TIMER4 TEST =================================
;    1017 // [μ]: void
;    1018 // ----------------------------------------------------------------------------
;    1019 void timer4_test(void)
;    1020 {
_timer4_test:
;    1021 int exit_flg = 0;
;    1022 
;    1023 	printf("=================== TIMER4 TEST =================\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1658
	CALL SUBOPT_0x11
;    1024 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;    1025 	printf("- interrupt    : TIMER4 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,1710
	CALL SUBOPT_0x11
;    1026 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	CALL SUBOPT_0x18
;    1027 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;    1028 
;    1029 // Timer/Counter4 (Overflow)
;    1030 	TCCR4A=0x00;
	LDI  R30,LOW(0)
	STS  160,R30
;    1031 	TCCR4B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	STS  161,R30
;    1032 	TCNT4H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xD
;    1033 	TCNT4L=0x3b;
;    1034 	ICR4H=0x00;
	LDI  R30,LOW(0)
	STS  167,R30
;    1035 	ICR4L=0x00;
	STS  166,R30
;    1036 	OCR4AH=0x00;
	STS  169,R30
;    1037 	OCR4AL=0x00;
	STS  168,R30
;    1038 	OCR4BH=0x00;
	STS  171,R30
;    1039 	OCR4BL=0x00;
	STS  170,R30
;    1040 	OCR4CH=0x00;
	STS  173,R30
;    1041 	OCR4CL=0x00;
	STS  172,R30
;    1042 	TIMSK4 |= 0x01;						// TIMER4 ͷƮ 㰡
	LDS  R30,114
	ORI  R30,1
	STS  114,R30
;    1043 
;    1044 	timer4_cnt = 0;						// TIMER4 ͷƮ ī Ŭ
	LDI  R30,0
	STS  _timer4_cnt,R30
	STS  _timer4_cnt+1,R30
;    1045 	com1_rx_eflg = 0;
	CLR  R2
;    1046 	while(exit_flg == 0){					// COM1  ˻
_0x81:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x83
;    1047 		if(com1_rx_eflg){
	TST  R2
	BREQ _0x84
;    1048 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x85
	__GETWRN 16,17,1
;    1049 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x86
_0x85:
	ST   -Y,R3
	RCALL _putchar
;    1050 			com1_rx_eflg = 0;
_0x86:
	CLR  R2
;    1051 		}
;    1052 		if(timer4_cnt >= 100){				// 1s üũ
_0x84:
	LDS  R26,_timer4_cnt
	LDS  R27,_timer4_cnt+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x87
;    1053 			printf("TIMER4 Overflow Interrupt\r\n");
	__POINTW1FN _0,1762
	CALL SUBOPT_0x11
;    1054 			timer4_cnt = 0;
	LDI  R30,0
	STS  _timer4_cnt,R30
	STS  _timer4_cnt+1,R30
;    1055 		}
;    1056 	}
_0x87:
	RJMP _0x81
_0x83:
;    1057 
;    1058 // Timer/Counter4 
;    1059 	TCCR4A=0x00;
	CALL SUBOPT_0x6
;    1060 	TCCR4B=0x00;
;    1061 	TCNT4H=0x00;
;    1062 	TCNT4L=0x00;
;    1063 	ICR4H=0x00;
;    1064 	ICR4L=0x00;
;    1065 	OCR4AH=0x00;
;    1066 	OCR4AL=0x00;
;    1067 	OCR4BH=0x00;
;    1068 	OCR4BL=0x00;
;    1069 	OCR4CH=0x00;
;    1070 	OCR4CL=0x00;
;    1071 	TIMSK4 &= 0xfe;						// TIMER4 ͷƮ 
	LDS  R30,114
	ANDI R30,0xFE
	STS  114,R30
;    1072 
;    1073 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;    1074 }
	RJMP _0x1CF
;    1075 
;    1076 // ============================== TIMER5 TEST =================================
;    1077 // [μ]: void
;    1078 // ----------------------------------------------------------------------------
;    1079 void timer5_test(void)
;    1080 {
_timer5_test:
;    1081 int exit_flg = 0;
;    1082 
;    1083 	printf("=================== TIMER5 TEST =================\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1790
	CALL SUBOPT_0x11
;    1084 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;    1085 	printf("- interrupt    : TIMER5 Overfow 10.0ms           \r\n");
	__POINTW1FN _0,1842
	CALL SUBOPT_0x11
;    1086 	printf("- message disp : 10.0ms * 100 = 1s               \r\n");
	CALL SUBOPT_0x18
;    1087 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;    1088 
;    1089 // Timer/Counter5 (Overflow)
;    1090 	TCCR5A=0x00;
	LDI  R30,LOW(0)
	STS  288,R30
;    1091 	TCCR5B=0x03;						// system clock,16,000,000 / 64 = 250,000Khz
	LDI  R30,LOW(3)
	STS  289,R30
;    1092 	TCNT5H=0xf6;  						// 65535 - 2500 = 63035
	CALL SUBOPT_0xE
;    1093 	TCNT5L=0x3b;
;    1094 	ICR5H=0x00;
	LDI  R30,LOW(0)
	STS  295,R30
;    1095 	ICR5L=0x00;
	STS  294,R30
;    1096 	OCR5AH=0x00;
	STS  297,R30
;    1097 	OCR5AL=0x00;
	STS  296,R30
;    1098 	OCR5BH=0x00;
	STS  299,R30
;    1099 	OCR5BL=0x00;
	STS  298,R30
;    1100 	OCR5CH=0x00;
	STS  301,R30
;    1101 	OCR5CL=0x00;
	STS  300,R30
;    1102 	TIMSK5 |= 0x01;						// TIMER5 ͷƮ 㰡
	LDS  R30,115
	ORI  R30,1
	STS  115,R30
;    1103 
;    1104 	timer5_cnt = 0;						// TIMER5 ͷƮ ī Ŭ
	LDI  R30,0
	STS  _timer5_cnt,R30
	STS  _timer5_cnt+1,R30
;    1105 	com1_rx_eflg = 0;
	CLR  R2
;    1106 	while(exit_flg == 0){					// COM1  ˻
_0x88:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x8A
;    1107 		if(com1_rx_eflg){
	TST  R2
	BREQ _0x8B
;    1108 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x8C
	__GETWRN 16,17,1
;    1109 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x8D
_0x8C:
	ST   -Y,R3
	RCALL _putchar
;    1110 			com1_rx_eflg = 0;
_0x8D:
	CLR  R2
;    1111 		}
;    1112 		if(timer5_cnt >= 100){				// 1s üũ
_0x8B:
	LDS  R26,_timer5_cnt
	LDS  R27,_timer5_cnt+1
	CPI  R26,LOW(0x64)
	LDI  R30,HIGH(0x64)
	CPC  R27,R30
	BRLT _0x8E
;    1113 			printf("TIMER5 Overflow Interrupt\r\n");
	__POINTW1FN _0,1894
	CALL SUBOPT_0x11
;    1114 			timer5_cnt = 0;
	LDI  R30,0
	STS  _timer5_cnt,R30
	STS  _timer5_cnt+1,R30
;    1115 		}
;    1116 	}
_0x8E:
	RJMP _0x88
_0x8A:
;    1117 
;    1118 // Timer/Counter5 
;    1119 	TCCR5A=0x00;
	CALL SUBOPT_0x7
;    1120 	TCCR5B=0x00;
;    1121 	TCNT5H=0x00;
;    1122 	TCNT5L=0x00;
;    1123 	ICR5H=0x00;
;    1124 	ICR5L=0x00;
;    1125 	OCR5AH=0x00;
;    1126 	OCR5AL=0x00;
;    1127 	OCR5BH=0x00;
;    1128 	OCR5BL=0x00;
;    1129 	OCR5CH=0x00;
;    1130 	OCR5CL=0x00;
;    1131 	TIMSK5 &= 0xfe;						// TIMER5 ͷƮ 
	LDS  R30,115
	ANDI R30,0xFE
	STS  115,R30
;    1132 
;    1133 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;    1134 }
_0x1CF:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1135 
;    1136 // ============================== EXINT0,1 TEST ===============================
;    1137 // [μ]: void
;    1138 // ----------------------------------------------------------------------------
;    1139 void exint_test(void)
;    1140 {
_exint_test:
;    1141 int exit_flg = 0;
;    1142 
;    1143 	printf("=================== EXINT0,1 TEST ===============\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,1922
	CALL SUBOPT_0x11
;    1144 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;    1145 	printf("- interrupt : INT0 Falling Edge                  \r\n");
	__POINTW1FN _0,1974
	CALL SUBOPT_0x11
;    1146 	printf("-             INT1 Falling Edge                  \r\n");
	__POINTW1FN _0,2026
	CALL SUBOPT_0x11
;    1147 	printf("-             INT2 Falling Edge                  \r\n");
	__POINTW1FN _0,2078
	CALL SUBOPT_0x11
;    1148 	printf("-             INT3 Falling Edge                  \r\n");
	__POINTW1FN _0,2130
	CALL SUBOPT_0x11
;    1149 	printf("-             INT4 Falling Edge                  \r\n");
	__POINTW1FN _0,2182
	CALL SUBOPT_0x11
;    1150 	printf("-             INT5 Falling Edge                  \r\n");
	__POINTW1FN _0,2234
	CALL SUBOPT_0x11
;    1151 	printf("-             INT6 Falling Edge                  \r\n");
	__POINTW1FN _0,2286
	CALL SUBOPT_0x11
;    1152 	printf("-             INT7 Falling Edge                  \r\n");
	__POINTW1FN _0,2338
	CALL SUBOPT_0x11
;    1153 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;    1154 
;    1155 // External Interrupt(s) 
;    1156 // INT0 Mode: Falling Edge
;    1157 // INT1 Mode: Falling Edge
;    1158 // INT2 Mode: Falling Edge
;    1159 // INT3 Mode: Falling Edge
;    1160 // INT4 Mode: Falling Edge
;    1161 // INT5 Mode: Falling Edge
;    1162 // INT6 Mode: Falling Edge
;    1163 // INT7 Mode: Falling Edge
;    1164 	EICRA=0xAA;
	LDI  R30,LOW(170)
	STS  105,R30
;    1165 	EICRB=0xAA;
	STS  106,R30
;    1166 	EIMSK=0xFF;
	LDI  R30,LOW(255)
	OUT  0x1D,R30
;    1167 	EIFR=0xFF;
	OUT  0x1C,R30
;    1168 
;    1169 	exint0_flg = exint1_flg = exint2_flg = 0;		// EXINT0,1 ͷƮ ÷ Ŭ
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R31
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R31
	STS  _exint0_flg,R30
	STS  _exint0_flg+1,R31
;    1170 	com1_rx_eflg = 0;
	CLR  R2
;    1171 	while(exit_flg == 0){
_0x8F:
	MOV  R0,R16
	OR   R0,R17
	BREQ PC+3
	JMP _0x91
;    1172 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x92
;    1173 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x93
	__GETWRN 16,17,1
;    1174 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x94
_0x93:
	ST   -Y,R3
	RCALL _putchar
;    1175 			com1_rx_eflg = 0;
_0x94:
	CLR  R2
;    1176 		}
;    1177 		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
_0x92:
	LDS  R30,_exint0_flg
	LDS  R31,_exint0_flg+1
	SBIW R30,0
	BREQ _0x95
;    1178 			printf("EXINT0 Interrupt\r\n");
	__POINTW1FN _0,2390
	CALL SUBOPT_0x11
;    1179 			exint0_flg = 0;
	LDI  R30,0
	STS  _exint0_flg,R30
	STS  _exint0_flg+1,R30
;    1180 		}
;    1181 		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
_0x95:
	LDS  R30,_exint1_flg
	LDS  R31,_exint1_flg+1
	SBIW R30,0
	BREQ _0x96
;    1182 			printf("EXINT1 Interrupt\r\n");
	__POINTW1FN _0,2409
	CALL SUBOPT_0x11
;    1183 			exint1_flg = 0;
	LDI  R30,0
	STS  _exint1_flg,R30
	STS  _exint1_flg+1,R30
;    1184 		}
;    1185 		if(exint2_flg){					// EXINT2 ͷƮ ÷ üũ
_0x96:
	LDS  R30,_exint2_flg
	LDS  R31,_exint2_flg+1
	SBIW R30,0
	BREQ _0x97
;    1186 			printf("EXINT2 Interrupt\r\n");
	__POINTW1FN _0,2428
	CALL SUBOPT_0x11
;    1187 			exint2_flg = 0;
	LDI  R30,0
	STS  _exint2_flg,R30
	STS  _exint2_flg+1,R30
;    1188 		}
;    1189 		if(exint3_flg){					// EXINT3 ͷƮ ÷ üũ
_0x97:
	LDS  R30,_exint3_flg
	LDS  R31,_exint3_flg+1
	SBIW R30,0
	BREQ _0x98
;    1190 			printf("EXINT3 Interrupt\r\n");
	__POINTW1FN _0,2447
	CALL SUBOPT_0x11
;    1191 			exint3_flg = 0;
	LDI  R30,0
	STS  _exint3_flg,R30
	STS  _exint3_flg+1,R30
;    1192 		}
;    1193 		if(exint4_flg){					// EXINT4 ͷƮ ÷ üũ
_0x98:
	LDS  R30,_exint4_flg
	LDS  R31,_exint4_flg+1
	SBIW R30,0
	BREQ _0x99
;    1194 			printf("EXINT4 Interrupt\r\n");
	__POINTW1FN _0,2466
	CALL SUBOPT_0x11
;    1195 			exint4_flg = 0;
	LDI  R30,0
	STS  _exint4_flg,R30
	STS  _exint4_flg+1,R30
;    1196 		}
;    1197 		if(exint5_flg){					// EXINT5 ͷƮ ÷ üũ
_0x99:
	LDS  R30,_exint5_flg
	LDS  R31,_exint5_flg+1
	SBIW R30,0
	BREQ _0x9A
;    1198 			printf("EXINT5 Interrupt\r\n");
	__POINTW1FN _0,2485
	CALL SUBOPT_0x11
;    1199 			exint5_flg = 0;
	LDI  R30,0
	STS  _exint5_flg,R30
	STS  _exint5_flg+1,R30
;    1200 		}
;    1201 		if(exint6_flg){					// EXINT6 ͷƮ ÷ üũ
_0x9A:
	LDS  R30,_exint6_flg
	LDS  R31,_exint6_flg+1
	SBIW R30,0
	BREQ _0x9B
;    1202 			printf("EXINT6 Interrupt\r\n");
	__POINTW1FN _0,2504
	CALL SUBOPT_0x11
;    1203 			exint6_flg = 0;
	LDI  R30,0
	STS  _exint6_flg,R30
	STS  _exint6_flg+1,R30
;    1204 		}
;    1205 		if(exint7_flg){					// EXINT7 ͷƮ ÷ üũ
_0x9B:
	LDS  R30,_exint7_flg
	LDS  R31,_exint7_flg+1
	SBIW R30,0
	BREQ _0x9C
;    1206 			printf("EXINT7 Interrupt\r\n");
	__POINTW1FN _0,2523
	CALL SUBOPT_0x11
;    1207 			exint7_flg = 0;
	LDI  R30,0
	STS  _exint7_flg,R30
	STS  _exint7_flg+1,R30
;    1208 		}
;    1209 	}
_0x9C:
	RJMP _0x8F
_0x91:
;    1210 
;    1211 // External Interrupt(s) 
;    1212 	EICRA=0x00;
	CALL SUBOPT_0x8
;    1213 	EICRB=0x00;
;    1214 	EIMSK=0x00;
;    1215 	EIFR=0x00;
	OUT  0x1C,R30
;    1216 
;    1217 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;    1218 }
	RJMP _0x1CC
;    1219 
;    1220 // ============================== A/D POLLING TEST ============================
;    1221 // [μ]: void
;    1222 // ----------------------------------------------------------------------------
;    1223 void ad_polling_test(void)
;    1224 {
_ad_polling_test:
;    1225 unsigned datau;
;    1226 int exit_flg = 0;
;    1227 
;    1228 	printf("================= A/D POLLING TEST ==============\r\n");
	CALL SUBOPT_0x12
;	datau -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,2542
	CALL SUBOPT_0x11
;    1229 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;    1230 	printf("- 1  : CH0 READ                                  \r\n");
	__POINTW1FN _0,2594
	CALL SUBOPT_0x11
;    1231 	printf("- 2  : CH1 READ                                  \r\n");
	__POINTW1FN _0,2646
	CALL SUBOPT_0x11
;    1232 	printf("- 3  : CH2 READ                                  \r\n");
	__POINTW1FN _0,2698
	CALL SUBOPT_0x11
;    1233 	printf("- 4  : CH3 READ                                  \r\n");
	__POINTW1FN _0,2750
	CALL SUBOPT_0x11
;    1234 	printf("- 5  : CH4 READ                                  \r\n");
	__POINTW1FN _0,2802
	CALL SUBOPT_0x11
;    1235 	printf("- 6  : CH5 READ                                  \r\n");
	__POINTW1FN _0,2854
	CALL SUBOPT_0x11
;    1236 	printf("- 7  : CH6 READ                                  \r\n");
	__POINTW1FN _0,2906
	CALL SUBOPT_0x11
;    1237 	printf("- 8  : CH7 READ                                  \r\n");
	__POINTW1FN _0,2958
	CALL SUBOPT_0x11
;    1238 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;    1239 
;    1240 // Digital input buffers on
;    1241 //  ADC0: On, ADC1: On, ADC2: On, ADC3: On, ADC4: On, ADC5: On, ADC6: On, ADC7: On
;    1242 	DIDR0=0x00;
	CALL SUBOPT_0x19
;    1243 // Digital input buffers on
;    1244 // ADC8: On, ADC9: On, ADC10: On, ADC11: On, ADC12: On, ADC13: On, ADC14: On, ADC15: On
;    1245 	DIDR2=0x00;
;    1246 // ADC initialization 
;    1247 	ADMUX = 0x00;						//   AREF
;    1248 	ADCSRA = 0x87;						// ADC Enable,ADC Clock 125.000Khz
	LDI  R30,LOW(135)
	STS  122,R30
;    1249 
;    1250 	com1_rx_eflg = 0;
	CLR  R2
;    1251 	while(exit_flg == 0){
_0x9D:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+3
	JMP _0x9F
;    1252 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BRNE PC+3
	JMP _0xA0
;    1253 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0xA1
	__GETWRN 18,19,1
;    1254 			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
	RJMP _0xA2
_0xA1:
	LDI  R30,LOW(49)
	CP   R30,R3
	BRNE _0xA3
	LDI  R30,LOW(0)
	CALL SUBOPT_0x1A
;    1255 			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
	RJMP _0xA4
_0xA3:
	LDI  R30,LOW(50)
	CP   R30,R3
	BRNE _0xA5
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1A
;    1256 			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
	RJMP _0xA6
_0xA5:
	LDI  R30,LOW(51)
	CP   R30,R3
	BRNE _0xA7
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1A
;    1257 			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
	RJMP _0xA8
_0xA7:
	LDI  R30,LOW(52)
	CP   R30,R3
	BRNE _0xA9
	LDI  R30,LOW(3)
	CALL SUBOPT_0x1A
;    1258 			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
	RJMP _0xAA
_0xA9:
	LDI  R30,LOW(53)
	CP   R30,R3
	BRNE _0xAB
	LDI  R30,LOW(4)
	CALL SUBOPT_0x1A
;    1259 			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
	RJMP _0xAC
_0xAB:
	LDI  R30,LOW(54)
	CP   R30,R3
	BRNE _0xAD
	LDI  R30,LOW(5)
	CALL SUBOPT_0x1A
;    1260 			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
	RJMP _0xAE
_0xAD:
	LDI  R30,LOW(55)
	CP   R30,R3
	BRNE _0xAF
	LDI  R30,LOW(6)
	CALL SUBOPT_0x1A
;    1261 			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
	RJMP _0xB0
_0xAF:
	LDI  R30,LOW(56)
	CP   R30,R3
	BRNE _0xB1
	LDI  R30,LOW(7)
	CALL SUBOPT_0x1A
;    1262 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xB2
_0xB1:
	ST   -Y,R3
	RCALL _putchar
;    1263 			// A/D  ǥ
;    1264 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
_0xB2:
_0xB0:
_0xAE:
_0xAC:
_0xAA:
_0xA8:
_0xA6:
_0xA4:
_0xA2:
	LDI  R30,LOW(49)
	CP   R3,R30
	BRLO _0xB4
	LDI  R30,LOW(56)
	CP   R30,R3
	BRSH _0xB5
_0xB4:
	RJMP _0xB3
_0xB5:
	__POINTW1FN _0,3010
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R3
	ANDI R30,LOW(0xF)
	SUBI R30,LOW(1)
	CALL SUBOPT_0x1B
	MOVW R30,R16
	CALL SUBOPT_0x1C
;    1265 			com1_rx_eflg = 0;
_0xB3:
	CLR  R2
;    1266 		}
;    1267 	}
_0xA0:
	RJMP _0x9D
_0x9F:
;    1268 
;    1269 // ADC initialization 
;    1270 	DIDR0=0xff;
	CALL SUBOPT_0x1D
;    1271 	DIDR2=0xff;
;    1272 	ADMUX = 0x00;
;    1273 	ADCSRA = 0x00;
;    1274 
;    1275 	main_menu_disp();					//  ޴ ǥ
;    1276 }
_0x1CE:
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;    1277 
;    1278 // ============================== A/D POLLING TEST ============================
;    1279 // [μ]: unsigned char adc_input
;    1280 // ITEM1 : AD CH(0-7)
;    1281 // []: A/D 10bit
;    1282 // ----------------------------------------------------------------------------
;    1283 unsigned int ad_read(unsigned char adc_input)
;    1284 {
_ad_read:
;    1285 	ADMUX = adc_input;					// ADREF(0) + CH
;	adc_input -> Y+0
	CALL SUBOPT_0x1E
;    1286 	ADCSRA |= 0x40;						// AD conversion 
;    1287 	while((ADCSRA & 0x10) == 0);				//  Ϸ 
_0xB6:
	LDS  R30,122
	ANDI R30,LOW(0x10)
	BREQ _0xB6
;    1288 	ADCSRA |= 0x10;						// AD ÷ Ŭ
	LDS  R30,122
	ORI  R30,0x10
	STS  122,R30
;    1289 	return ADCW;
	LDS  R30,120
	LDS  R31,120+1
	RJMP _0x1CB
;    1290 }
;    1291 
;    1292 // ============================== A/D INTERRUPT TEST ==========================
;    1293 // [μ]: void
;    1294 // ----------------------------------------------------------------------------
;    1295 void ad_interrupt_test(void)
;    1296 {
_ad_interrupt_test:
;    1297 int exit_flg = 0;
;    1298 
;    1299 	printf("================ A/D INTEERRUPT TEST ============\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,3026
	CALL SUBOPT_0x11
;    1300 	printf("- 0  : TOP menu                                  \r\n");
	CALL SUBOPT_0x13
;    1301 	printf("- 1  : CH0 READ                                  \r\n");
	__POINTW1FN _0,2594
	CALL SUBOPT_0x11
;    1302 	printf("- 2  : CH1 READ                                  \r\n");
	__POINTW1FN _0,2646
	CALL SUBOPT_0x11
;    1303 	printf("- 3  : CH2 READ                                  \r\n");
	__POINTW1FN _0,2698
	CALL SUBOPT_0x11
;    1304 	printf("- 4  : CH3 READ                                  \r\n");
	__POINTW1FN _0,2750
	CALL SUBOPT_0x11
;    1305 	printf("- 5  : CH4 READ                                  \r\n");
	__POINTW1FN _0,2802
	CALL SUBOPT_0x11
;    1306 	printf("- 6  : CH5 READ                                  \r\n");
	__POINTW1FN _0,2854
	CALL SUBOPT_0x11
;    1307 	printf("- 7  : CH6 READ                                  \r\n");
	__POINTW1FN _0,2906
	CALL SUBOPT_0x11
;    1308 	printf("- 8  : CH7 READ                                  \r\n");
	__POINTW1FN _0,2958
	CALL SUBOPT_0x11
;    1309 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;    1310 
;    1311 // Digital input buffers on
;    1312 //  ADC0: On, ADC1: On, ADC2: On, ADC3: On, ADC4: On, ADC5: On, ADC6: On, ADC7: On
;    1313 	DIDR0=0x00;
	CALL SUBOPT_0x19
;    1314 // Digital input buffers on
;    1315 // ADC8: On, ADC9: On, ADC10: On, ADC11: On, ADC12: On, ADC13: On, ADC14: On, ADC15: On
;    1316 	DIDR2=0x00;
;    1317 // ADC initialization 
;    1318 	ADMUX = 0x00;						//   AREF
;    1319 	ADCSRA = 0x8f;						// ADC Enable,ADC Clock 125.000Khz,ADC ȯ ͷƮ Ȱȭ
	LDI  R30,LOW(143)
	STS  122,R30
;    1320 
;    1321 	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
;    1322 	adc_int_ch = 0;						// ADC CH = CH0
	LDI  R30,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R30
;    1323 	com1_rx_eflg = 0;
	CLR  R2
;    1324 	while(exit_flg == 0){
_0xB9:
	MOV  R0,R16
	OR   R0,R17
	BREQ PC+3
	JMP _0xBB
;    1325 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BRNE PC+3
	JMP _0xBC
;    1326 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0xBD
	__GETWRN 16,17,1
;    1327 			else if(com1_rx_data == '1') ad_start(0);// CH0 
	RJMP _0xBE
_0xBD:
	LDI  R30,LOW(49)
	CP   R30,R3
	BRNE _0xBF
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _ad_start
;    1328 			else if(com1_rx_data == '2') ad_start(1);// CH1 
	RJMP _0xC0
_0xBF:
	LDI  R30,LOW(50)
	CP   R30,R3
	BRNE _0xC1
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _ad_start
;    1329 			else if(com1_rx_data == '3') ad_start(2);// CH2 
	RJMP _0xC2
_0xC1:
	LDI  R30,LOW(51)
	CP   R30,R3
	BRNE _0xC3
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _ad_start
;    1330 			else if(com1_rx_data == '4') ad_start(3);// CH3 
	RJMP _0xC4
_0xC3:
	LDI  R30,LOW(52)
	CP   R30,R3
	BRNE _0xC5
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _ad_start
;    1331 			else if(com1_rx_data == '5') ad_start(4);// CH4 
	RJMP _0xC6
_0xC5:
	LDI  R30,LOW(53)
	CP   R30,R3
	BRNE _0xC7
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _ad_start
;    1332 			else if(com1_rx_data == '6') ad_start(5);// CH5 
	RJMP _0xC8
_0xC7:
	LDI  R30,LOW(54)
	CP   R30,R3
	BRNE _0xC9
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _ad_start
;    1333 			else if(com1_rx_data == '7') ad_start(6);// CH6 
	RJMP _0xCA
_0xC9:
	LDI  R30,LOW(55)
	CP   R30,R3
	BRNE _0xCB
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _ad_start
;    1334 			else if(com1_rx_data == '8') ad_start(7);// CH7 
	RJMP _0xCC
_0xCB:
	LDI  R30,LOW(56)
	CP   R30,R3
	BRNE _0xCD
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _ad_start
;    1335 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xCE
_0xCD:
	ST   -Y,R3
	RCALL _putchar
;    1336 			// A/D  ǥ
;    1337 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
_0xCE:
_0xCC:
_0xCA:
_0xC8:
_0xC6:
_0xC4:
_0xC2:
_0xC0:
_0xBE:
	LDI  R30,LOW(49)
	CP   R3,R30
	BRLO _0xD0
	LDI  R30,LOW(56)
	CP   R30,R3
	BRSH _0xD1
_0xD0:
	RJMP _0xCF
_0xD1:
	__POINTW1FN _0,3078
	CALL SUBOPT_0x11
;    1338 			com1_rx_eflg = 0;
_0xCF:
	CLR  R2
;    1339 		}
;    1340 		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷
_0xBC:
	LDS  R30,_adc_int_flg
	LDS  R31,_adc_int_flg+1
	SBIW R30,0
	BREQ _0xD2
;    1341 			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
	__POINTW1FN _0,3014
	ST   -Y,R31
	ST   -Y,R30
	LDS  R30,_adc_int_ch
	LDS  R31,_adc_int_ch+1
	CALL __CWD1
	CALL __PUTPARD1
	LDS  R30,_adc_int_data
	LDS  R31,_adc_int_data+1
	CALL SUBOPT_0x1C
;    1342 			adc_int_flg = 0;
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
;    1343 		}
;    1344 	}
_0xD2:
	RJMP _0xB9
_0xBB:
;    1345 
;    1346 // ADC initialization 
;    1347 	DIDR0=0xff;
	CALL SUBOPT_0x1D
;    1348 	DIDR2=0xff;
;    1349 	ADMUX = 0x00;
;    1350 	ADCSRA = 0x00;
;    1351 
;    1352 	main_menu_disp();					//  ޴ ǥ
;    1353 }
	RJMP _0x1CC
;    1354 
;    1355 // ============================== A/D POLLING TEST ============================
;    1356 // [μ]: unsigned char adc_input
;    1357 // ITEM1 : AD CH(0-7)
;    1358 // []: A/D 10bit
;    1359 // ----------------------------------------------------------------------------
;    1360 void ad_start(unsigned char adc_input)
;    1361 {
_ad_start:
;    1362 	adc_int_ch = adc_input;					// ADC CH 
;	adc_input -> Y+0
	LD   R30,Y
	LDI  R31,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R31
;    1363 	ADMUX = adc_input;					// ADREF(0) + CH
	CALL SUBOPT_0x1E
;    1364 	ADCSRA |= 0x40;						// AD conversion 
;    1365 }
	RJMP _0x1CB
;    1366 
;    1367 // ================================ EEPROM TEST ===============================
;    1368 // [μ]: void
;    1369 // ----------------------------------------------------------------------------
;    1370 void eeprom_test(void)
;    1371 {
_eeprom_test:
;    1372 char ch,buff[100],buff1[30],buff2[30],buff3[30];
;    1373 unsigned char uch;
;    1374 int i,j,cnt,exit_flg = 0;
;    1375 unsigned int saddr,ecnt;
;    1376 
;    1377 	printf("============== INTERNAL EEPROM TEST =============\r\n");
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,9
	LDI  R24,2
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	LDI  R30,LOW(_0xD3*2)
	LDI  R31,HIGH(_0xD3*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	ch -> R17
;	buff -> Y+104
;	buff1 -> Y+74
;	buff2 -> Y+44
;	buff3 -> Y+14
;	uch -> R16
;	i -> R18,R19
;	j -> R20,R21
;	cnt -> Y+12
;	exit_flg -> Y+10
;	saddr -> Y+8
;	ecnt -> Y+6
	__POINTW1FN _0,3088
	CALL SUBOPT_0x11
;    1378 	printf("- 0 : TOP menu                                   \r\n");
	__POINTW1FN _0,3140
	CALL SUBOPT_0x11
;    1379 	printf("  1 : Read  Data(000-1fffh)                       \r\n");
	__POINTW1FN _0,3192
	CALL SUBOPT_0x11
;    1380 	printf("  2 : Write Data(000-1fffh)                       \r\n");
	__POINTW1FN _0,3245
	CALL SUBOPT_0x11
;    1381 	printf("-------------------------------------------------\r\n");
	CALL SUBOPT_0x14
;    1382 
;    1383 	com1_rx_eflg = 0;
	CLR  R2
;    1384 	while(exit_flg == 0){
_0xD4:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BREQ PC+3
	JMP _0xD6
;    1385 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BRNE PC+3
	JMP _0xD7
;    1386 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0xD8
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+10,R30
	STD  Y+10+1,R31
;    1387 			else if(com1_rx_data == '1'){
	RJMP _0xD9
_0xD8:
	LDI  R30,LOW(49)
	CP   R30,R3
	BREQ PC+3
	JMP _0xDA
;    1388 				i = j = cnt = 0;
	CALL SUBOPT_0x1F
;    1389 				printf("\r\nREAD(###(Add),***(Count)) > ");
	__POINTW1FN _0,3298
	CALL SUBOPT_0x11
;    1390 				urx_string(buff);
	CALL SUBOPT_0x20
;    1391 				ch = buff[i++];			//  ˻ ڷ 
;    1392 				while(ch != 0x0){
_0xDB:
	CPI  R17,0
	BREQ _0xDD
;    1393 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xDF
	CPI  R17,44
	BREQ _0xDF
	CPI  R17,32
	BRNE _0xDE
_0xDF:
;    1394 						j = 0;
	CALL SUBOPT_0x21
;    1395 						cnt++;
;    1396 					}
;    1397 					else{
	RJMP _0xE1
_0xDE:
;    1398 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xE2
;    1399 							buff1[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x23
;    1400 							buff1[j] = 0x0;
	RJMP _0x1D1
;    1401 						}
;    1402 						else if(cnt == 1){
_0xE2:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BRNE _0xE4
;    1403 				    			buff2[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x24
;    1404 				    			buff2[j] = 0x0;
_0x1D1:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1405 						}
;    1406 			    		}
_0xE4:
_0xE1:
;    1407 				    	ch = buff[i++];
	CALL SUBOPT_0x25
;    1408 				}
	RJMP _0xDB
_0xDD:
;    1409 				if(cnt == 1){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BREQ PC+3
	JMP _0xE5
;    1410 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	CALL SUBOPT_0x26
;    1411 					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
;    1412 					printf("%04X > ",saddr);// ּ ǥ
	__POINTW1FN _0,3329
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL SUBOPT_0x27
;    1413 					cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;    1414 			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
	__GETWRN 18,19,0
_0xE7:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xE8
;    1415 						uch = EEPROM_read(saddr);//  
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _EEPROM_read
	MOV  R16,R30
;    1416 						printf("%02X ",uch);// Ÿ ǥ
	CALL SUBOPT_0x28
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
;    1417 						cnt++;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1418 						if(cnt == 16){// 1 ǥ
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,16
	BRNE _0xE9
;    1419 							cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;    1420 							if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
	MOVW R26,R18
	ADIW R26,1
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRLO _0xEA
	__POINTW1FN _0,3343
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	CALL SUBOPT_0x27
;    1421 						}
_0xEA:
;    1422 				    	}
_0xE9:
	CALL SUBOPT_0x29
	RJMP _0xE7
_0xE8:
;    1423 					printf("\r\nRead OK\r\n");
	__POINTW1FN _0,3353
	CALL SUBOPT_0x11
;    1424 				}
;    1425 			}
_0xE5:
;    1426 			else if(com1_rx_data == '2'){
	RJMP _0xEB
_0xDA:
	LDI  R30,LOW(50)
	CP   R30,R3
	BREQ PC+3
	JMP _0xEC
;    1427 				i = j = cnt = 0;
	CALL SUBOPT_0x1F
;    1428 				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
	__POINTW1FN _0,3365
	CALL SUBOPT_0x11
;    1429 				urx_string(buff);
	CALL SUBOPT_0x20
;    1430 				ch = buff[i++];			//  ˻ ڷ 
;    1431 				while(ch != 0x0){
_0xED:
	CPI  R17,0
	BREQ _0xEF
;    1432 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xF1
	CPI  R17,44
	BREQ _0xF1
	CPI  R17,32
	BRNE _0xF0
_0xF1:
;    1433 						j = 0;
	CALL SUBOPT_0x21
;    1434 						cnt++;
;    1435 					}
;    1436 					else{
	RJMP _0xF3
_0xF0:
;    1437 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xF4
;    1438 							buff1[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x23
;    1439 							buff1[j] = 0x0;
	RJMP _0x1D2
;    1440 						}
;    1441 						else if(cnt == 1){
_0xF4:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	BRNE _0xF6
;    1442 							buff2[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x24
;    1443 							buff2[j] = 0x0;
	RJMP _0x1D2
;    1444 						}
;    1445 						else if(cnt == 2){
_0xF6:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xF8
;    1446 							buff3[j++] = ch;
	CALL SUBOPT_0x22
	MOVW R26,R28
	ADIW R26,14
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;    1447 							buff3[j] = 0x0;
	MOVW R26,R28
	ADIW R26,14
_0x1D2:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1448 						}
;    1449 					}
_0xF8:
_0xF3:
;    1450 					ch = buff[i++];
	CALL SUBOPT_0x25
;    1451 				}
	RJMP _0xED
_0xEF:
;    1452 				if(cnt == 2){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xF9
;    1453 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	CALL SUBOPT_0x26
;    1454 					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
;    1455 					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
	MOVW R30,R28
	ADIW R30,14
	CALL SUBOPT_0x2A
	MOV  R16,R30
;    1456 					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
	__GETWRN 18,19,0
_0xFB:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xFC
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R16
	RCALL _EEPROM_write
;    1457 					printf("SRAM Data Write OK\r\n");
	CALL SUBOPT_0x29
	RJMP _0xFB
_0xFC:
	__POINTW1FN _0,3407
	CALL SUBOPT_0x11
;    1458 				}
;    1459 			}
_0xF9:
;    1460 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xFD
_0xEC:
	ST   -Y,R3
	RCALL _putchar
;    1461 			com1_rx_eflg = 0;
_0xFD:
_0xEB:
_0xD9:
	CLR  R2
;    1462 		}
;    1463 	}
_0xD7:
	RJMP _0xD4
_0xD6:
;    1464 	main_menu_disp();					//  ޴ ǥ
	CALL _main_menu_disp
;    1465 }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,15
	RET
;    1466 
;    1467 // ============================== EEPROM DATA READ ============================
;    1468 // [μ] int addr
;    1469 // Item1:  ּ(0 - 8191)
;    1470 // []  (00 - ff)
;    1471 // ----------------------------------------------------------------------------
;    1472 unsigned char EEPROM_read(int addr)
;    1473 {
_EEPROM_read:
;    1474 unsigned char ch;
;    1475 
;    1476 	while(EECR & 0x02);					//   Ϸñ 
	ST   -Y,R17
;	addr -> Y+1
;	ch -> R17
_0xFE:
	SBIC 0x1F,1
	RJMP _0xFE
;    1477 	EEAR = addr;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x21+1,R31
	OUT  0x21,R30
;    1478 	EECR |= 0x01;
	SBI  0x1F,0
;    1479 	ch = EEDR;
	IN   R17,32
;    1480 	return(ch);
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x1CD
;    1481 }
;    1482 
;    1483 // ================================= EEPROM DATA  =========================
;    1484 // [μ] int addr,unsigned char data
;    1485 // Item1:  ּ(0 - 8191)
;    1486 // Item2:  (00 - ff)
;    1487 // ----------------------------------------------------------------------------
;    1488 void EEPROM_write(int addr,unsigned char data)
;    1489 {
_EEPROM_write:
;    1490 	while(EECR & 0x02);					//   Ϸñ 
;	addr -> Y+1
;	data -> Y+0
_0x101:
	SBIC 0x1F,1
	RJMP _0x101
;    1491 	EEAR = addr;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x21+1,R31
	OUT  0x21,R30
;    1492 	EEDR = data;
	LD   R30,Y
	OUT  0x20,R30
;    1493 	EECR |= 0x04;
	SBI  0x1F,2
;    1494 	EECR |= 0x02;
	SBI  0x1F,1
;    1495 }
_0x1CD:
	ADIW R28,3
	RET
;    1496 
;    1497 // ============================== SRAM ׽Ʈ α׷ ========================
;    1498 // [μ] void
;    1499 // ---------------------------------------------------------------------------
;    1500 void sram_test(void)
;    1501 {
_sram_test:
;    1502 char ch,buff[100],buff1[30],buff2[30],buff3[30];
;    1503 unsigned char uch;
;    1504 int i,j,cnt,exit_flg = 0;
;    1505 unsigned int saddr,ecnt;
;    1506 unsigned char *sram_base = (unsigned char*)0x0;
;    1507 
;    1508 	printf("============ SRAM TEST ============\r\n");
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,11
	LDI  R24,8
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x104*2)
	LDI  R31,HIGH(_0x104*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	ch -> R17
;	buff -> Y+106
;	buff1 -> Y+76
;	buff2 -> Y+46
;	buff3 -> Y+16
;	uch -> R16
;	i -> R18,R19
;	j -> R20,R21
;	cnt -> Y+14
;	exit_flg -> Y+12
;	saddr -> Y+10
;	ecnt -> Y+8
;	*sram_base -> Y+6
	__POINTW1FN _0,3428
	CALL SUBOPT_0x11
;    1509 	printf("- 0 : TOP MENU                    -\r\n");
	__POINTW1FN _0,3466
	CALL SUBOPT_0x11
;    1510 	printf("- 1 : Read  Data(0000-ffffh)      -\r\n");
	__POINTW1FN _0,3504
	CALL SUBOPT_0x11
;    1511 	printf("- 2 : Write Data(0000-ffffh)      -\r\n");
	__POINTW1FN _0,3542
	CALL SUBOPT_0x11
;    1512 	printf("-----------------------------------\r\n");
	__POINTW1FN _0,988
	CALL SUBOPT_0x11
;    1513 // External SRAM page configuration:
;    1514 //              -              / 0000h - FFFFh
;    1515 // Lower page wait state(s): None
;    1516 // Upper page wait state(s): None
;    1517 	MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
;    1518 	XMCRA=0x80;
	LDI  R30,LOW(128)
	STS  116,R30
;    1519 
;    1520 	com1_rx_eflg = 0;
	CLR  R2
;    1521 	while(exit_flg == 0){
_0x105:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BREQ PC+3
	JMP _0x107
;    1522 	    if(com1_rx_eflg == 1){
	LDI  R30,LOW(1)
	CP   R30,R2
	BREQ PC+3
	JMP _0x108
;    1523 			com1_rx_eflg = 0;
	CLR  R2
;    1524 			switch(com1_rx_data){
	MOV  R30,R3
;    1525 			    case   '0': exit_flg = 1; break;
	CPI  R30,LOW(0x30)
	BRNE _0x10C
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+12,R30
	STD  Y+12+1,R31
	RJMP _0x10B
;    1526 			    case   '1': i = j = cnt = 0;
_0x10C:
	CPI  R30,LOW(0x31)
	BREQ PC+3
	JMP _0x10D
	CALL SUBOPT_0x2B
;    1527 					printf("\r\nREAD(#####(A),***(C)) > ");
	__POINTW1FN _0,3580
	CALL SUBOPT_0x11
;    1528 					urx_string(buff);
	CALL SUBOPT_0x2C
;    1529 					ch = buff[i++];		//  ˻ ڷ 
;    1530 					while(ch != 0x0){
_0x10E:
	CPI  R17,0
	BREQ _0x110
;    1531 				    		if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0x112
	CPI  R17,44
	BREQ _0x112
	CPI  R17,32
	BRNE _0x111
_0x112:
;    1532 							j = 0;
	CALL SUBOPT_0x2D
;    1533 							cnt++;
;    1534 						}
;    1535 						else{
	RJMP _0x114
_0x111:
;    1536 							if(cnt == 0){
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BRNE _0x115
;    1537 					    			buff1[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2E
;    1538 								buff1[j] = 0x0;
	RJMP _0x1D3
;    1539 							}
;    1540 							else if(cnt == 1){
_0x115:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BRNE _0x117
;    1541 					    			buff2[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2F
;    1542 					    			buff2[j] = 0x0;
_0x1D3:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1543 							}
;    1544 				    		}
_0x117:
_0x114:
;    1545 					    		ch = buff[i++];
	CALL SUBOPT_0x30
;    1546 					}
	RJMP _0x10E
_0x110:
;    1547 					if(cnt == 1){		// ˻ 
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BREQ PC+3
	JMP _0x118
;    1548 						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	MOVW R30,R28
	SUBI R30,LOW(-(76))
	SBCI R31,HIGH(-(76))
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x31
;    1549 						ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1550 						printf("%04X > ",saddr);// ּ ǥ
	__POINTW1FN _0,3329
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	CALL SUBOPT_0x27
;    1551 						cnt = 0;
	LDI  R30,0
	STD  Y+14,R30
	STD  Y+14+1,R30
;    1552 				   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
	__GETWRN 18,19,0
_0x11A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0x11B
;    1553 							uch = sram_base[saddr];//  
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X
;    1554 							printf("%02X ",uch);// Ÿ ǥ
	CALL SUBOPT_0x28
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
;    1555 							cnt++;
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
;    1556 							if(cnt == 16){// 1 ǥ
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,16
	BRNE _0x11C
;    1557 								cnt = 0;
	LDI  R30,0
	STD  Y+14,R30
	STD  Y+14+1,R30
;    1558 								if(i+1 <= ecnt) printf("\r\n%04X > ",saddr+1);// ּ ǥ
	MOVW R26,R18
	ADIW R26,1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R26
	CPC  R31,R27
	BRLO _0x11D
	__POINTW1FN _0,3343
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	CALL SUBOPT_0x27
;    1559 							}
_0x11D:
;    1560 					    	}
_0x11C:
	CALL SUBOPT_0x32
	RJMP _0x11A
_0x11B:
;    1561 						printf("\r\nRead OK\r\n");
	__POINTW1FN _0,3353
	CALL SUBOPT_0x11
;    1562 					}
;    1563 					break;
_0x118:
	RJMP _0x10B
;    1564 			    case  '2' : i = j = cnt = 0;
_0x10D:
	CPI  R30,LOW(0x32)
	BREQ PC+3
	JMP _0x12F
	CALL SUBOPT_0x2B
;    1565 					printf("\r\nWRITE(#####(A),***(C),**(D)) > ");
	__POINTW1FN _0,3607
	CALL SUBOPT_0x11
;    1566 					urx_string(buff);
	CALL SUBOPT_0x2C
;    1567 					ch = buff[i++];		//  ˻ ڷ 
;    1568 					while(ch != 0x0){
_0x11F:
	CPI  R17,0
	BREQ _0x121
;    1569 						if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0x123
	CPI  R17,44
	BREQ _0x123
	CPI  R17,32
	BRNE _0x122
_0x123:
;    1570 							j = 0;
	CALL SUBOPT_0x2D
;    1571 							cnt++;
;    1572 						}
;    1573 						else{
	RJMP _0x125
_0x122:
;    1574 							if(cnt == 0){
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BRNE _0x126
;    1575 								buff1[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2E
;    1576 								buff1[j] = 0x0;
	RJMP _0x1D4
;    1577 							}
;    1578 							else if(cnt == 1){
_0x126:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,1
	BRNE _0x128
;    1579 								buff2[j++] = ch;
	CALL SUBOPT_0x22
	CALL SUBOPT_0x2F
;    1580 								buff2[j] = 0x0;
	RJMP _0x1D4
;    1581 							}
;    1582 							else if(cnt == 2){
_0x128:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,2
	BRNE _0x12A
;    1583 								buff3[j++] = ch;
	CALL SUBOPT_0x22
	MOVW R26,R28
	ADIW R26,16
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;    1584 								buff3[j] = 0x0;
	MOVW R26,R28
	ADIW R26,16
_0x1D4:
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	ST   X,R30
;    1585 							}
;    1586 						}
_0x12A:
_0x125:
;    1587 							    ch = buff[i++];
	CALL SUBOPT_0x30
;    1588 					}
	RJMP _0x11F
_0x121:
;    1589 					if(cnt == 2){		// ˻ 
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,2
	BRNE _0x12B
;    1590 						saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	MOVW R30,R28
	SUBI R30,LOW(-(76))
	SBCI R31,HIGH(-(76))
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x31
;    1591 						ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1592 						uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
	MOVW R30,R28
	ADIW R30,16
	CALL SUBOPT_0x2A
	MOV  R16,R30
;    1593 						for(i = 0; i <= ecnt; i++,saddr++){
	__GETWRN 18,19,0
_0x12D:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	CP   R30,R18
	CPC  R31,R19
	BRLO _0x12E
;    1594 							sram_base[saddr] = uch;//  
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R16
;    1595 						}
	CALL SUBOPT_0x32
	RJMP _0x12D
_0x12E:
;    1596 //						for(i = 0; i < ecnt; i++) sram_base[saddr+i] = uch;//  
;    1597 						printf("SRAM Data Write OK\r\n");
	__POINTW1FN _0,3407
	CALL SUBOPT_0x11
;    1598 					}
;    1599 					break;
_0x12B:
;    1600 		    	    default   : break;
_0x12F:
;    1601 			}
_0x10B:
;    1602 		}
;    1603 	}
_0x108:
	RJMP _0x105
_0x107:
;    1604 	com1_rx_eflg = 0;
	CLR  R2
;    1605 	main_menu_disp();					// ޴ ǥ
	CALL _main_menu_disp
;    1606 	MCUCR=0x00;						// clear exram config
	LDI  R30,LOW(0)
	OUT  0x35,R30
;    1607 	XMCRA=0x00;
	STS  116,R30
;    1608 }
	CALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,17
	RET
;    1609 
;    1610 // ==================================== COM2 TEST =============================
;    1611 // [μ] void
;    1612 // ----------------------------------------------------------------------------
;    1613 void com2_test(void)
;    1614 {
_com2_test:
;    1615 int exit_flg = 0;
;    1616 
;    1617 	printf("============== COM2 LOOPBACK TEST ==============\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,3641
	CALL SUBOPT_0x11
;    1618 	printf("- 0  : RETURN TOP MENU                          \r\n");
	CALL SUBOPT_0x33
;    1619 	printf("------------------------------------------------\r\n");
	CALL SUBOPT_0x34
;    1620 
;    1621 	com1_rx_eflg = com2_rx_eflg = 0;
	LDI  R30,LOW(0)
	MOV  R4,R30
	MOV  R2,R30
;    1622 	while(exit_flg == 0){
_0x130:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x132
;    1623 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x133
;    1624 			if(com1_rx_data == '0') exit_flg = 1;
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x134
	__GETWRN 16,17,1
;    1625 			else putchar1(com1_rx_data);		// COM2 send
	RJMP _0x135
_0x134:
	ST   -Y,R3
	RCALL _putchar1
;    1626 			com1_rx_eflg = 0;
_0x135:
	CLR  R2
;    1627 		}
;    1628 		if(com2_rx_eflg){				// COM2  ˻
_0x133:
	TST  R4
	BREQ _0x136
;    1629 			putchar(com2_rx_data);			// COM1 send
	ST   -Y,R5
	RCALL _putchar
;    1630 			com2_rx_eflg = 0;
	CLR  R4
;    1631 		}
;    1632 	}
_0x136:
	RJMP _0x130
_0x132:
;    1633 	main_menu_disp();					// ޴ ǥ
	CALL _main_menu_disp
;    1634 }
	RJMP _0x1CC
;    1635 
;    1636 // ============================ COM2 1Ʈ ۽ ===========================
;    1637 // [μ] char c
;    1638 // Item1  ۽ 
;    1639 // ----------------------------------------------------------------------------
;    1640 void putchar1(char c)
;    1641 {
_putchar1:
;    1642 	while((UCSR1A & DATA_REGISTER_EMPTY)==0);
;	c -> Y+0
_0x137:
	LDS  R30,200
	ANDI R30,LOW(0x20)
	BREQ _0x137
;    1643 	UDR1 = c;
	LD   R30,Y
	STS  206,R30
;    1644 }
	RJMP _0x1CB
;    1645 
;    1646 // ==================================== COM3 TEST =============================
;    1647 // [μ] void
;    1648 // ----------------------------------------------------------------------------
;    1649 void com3_test(void)
;    1650 {
_com3_test:
;    1651 int exit_flg = 0;
;    1652 
;    1653 	printf("============== COM3 LOOPBACK TEST ==============\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,3743
	CALL SUBOPT_0x11
;    1654 	printf("- 0  : RETURN TOP MENU                          \r\n");
	CALL SUBOPT_0x33
;    1655 	printf("------------------------------------------------\r\n");
	CALL SUBOPT_0x34
;    1656 
;    1657 	com1_rx_eflg = com3_rx_eflg = 0;
	LDI  R30,LOW(0)
	MOV  R6,R30
	MOV  R2,R30
;    1658 	while(exit_flg == 0){
_0x13A:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x13C
;    1659 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x13D
;    1660 			if(com1_rx_data == '0') exit_flg = 1;
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x13E
	__GETWRN 16,17,1
;    1661 			else putchar2(com1_rx_data);		// COM3 send
	RJMP _0x13F
_0x13E:
	ST   -Y,R3
	RCALL _putchar2
;    1662 			com1_rx_eflg = 0;
_0x13F:
	CLR  R2
;    1663 		}
;    1664 		if(com3_rx_eflg){				// COM3  ˻
_0x13D:
	TST  R6
	BREQ _0x140
;    1665 			putchar(com3_rx_data);			// COM1 send
	ST   -Y,R7
	RCALL _putchar
;    1666 			com3_rx_eflg = 0;
	CLR  R6
;    1667 		}
;    1668 	}
_0x140:
	RJMP _0x13A
_0x13C:
;    1669 	main_menu_disp();					// ޴ ǥ
	CALL _main_menu_disp
;    1670 }
	RJMP _0x1CC
;    1671 
;    1672 // ============================ COM3 1Ʈ ۽ ===========================
;    1673 // [μ] char c
;    1674 // Item1  ۽ 
;    1675 // ----------------------------------------------------------------------------
;    1676 void putchar2(char c)
;    1677 {
_putchar2:
;    1678 	while((UCSR2A & DATA_REGISTER_EMPTY)==0);
;	c -> Y+0
_0x141:
	LDS  R30,208
	ANDI R30,LOW(0x20)
	BREQ _0x141
;    1679 	UDR2 = c;
	LD   R30,Y
	STS  214,R30
;    1680 }
	RJMP _0x1CB
;    1681 
;    1682 // ==================================== COM4 TEST =============================
;    1683 // [μ] void
;    1684 // ----------------------------------------------------------------------------
;    1685 void com4_test(void)
;    1686 {
_com4_test:
;    1687 int exit_flg = 0;
;    1688 
;    1689 	printf("============== COM4 LOOPBACK TEST ==============\r\n");
	CALL SUBOPT_0x17
;	exit_flg -> R16,R17
	__POINTW1FN _0,3794
	CALL SUBOPT_0x11
;    1690 	printf("- 0  : RETURN TOP MENU                          \r\n");
	CALL SUBOPT_0x33
;    1691 	printf("------------------------------------------------\r\n");
	CALL SUBOPT_0x34
;    1692 
;    1693 	com1_rx_eflg = com4_rx_eflg = 0;
	LDI  R30,LOW(0)
	MOV  R8,R30
	MOV  R2,R30
;    1694 	while(exit_flg == 0){
_0x144:
	MOV  R0,R16
	OR   R0,R17
	BRNE _0x146
;    1695 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x147
;    1696 			if(com1_rx_data == '0') exit_flg = 1;
	LDI  R30,LOW(48)
	CP   R30,R3
	BRNE _0x148
	__GETWRN 16,17,1
;    1697 			else putchar3(com1_rx_data);		// COM4 send
	RJMP _0x149
_0x148:
	ST   -Y,R3
	RCALL _putchar3
;    1698 			com1_rx_eflg = 0;
_0x149:
	CLR  R2
;    1699 		}
;    1700 		if(com4_rx_eflg){				// COM4  ˻
_0x147:
	TST  R8
	BREQ _0x14A
;    1701 			putchar(com4_rx_data);			// COM1 send
	ST   -Y,R9
	RCALL _putchar
;    1702 			com4_rx_eflg = 0;
	CLR  R8
;    1703 		}
;    1704 	}
_0x14A:
	RJMP _0x144
_0x146:
;    1705 	main_menu_disp();					// ޴ ǥ
	CALL _main_menu_disp
;    1706 }
_0x1CC:
	LD   R16,Y+
	LD   R17,Y+
	RET
;    1707 
;    1708 // ============================ COM3 1Ʈ ۽ ===========================
;    1709 // [μ] char c
;    1710 // Item1  ۽ 
;    1711 // ----------------------------------------------------------------------------
;    1712 void putchar3(char c)
;    1713 {
_putchar3:
;    1714 	while((UCSR3A & DATA_REGISTER_EMPTY)==0);
;	c -> Y+0
_0x14B:
	LDS  R30,304
	ANDI R30,LOW(0x20)
	BREQ _0x14B
;    1715 	UDR3 = c;
	LD   R30,Y
	STS  310,R30
;    1716 }
	RJMP _0x1CB
;    1717 
;    1718 // ============================ κ ڿ  ====================
;    1719 // [μ] char buff[]
;    1720 // Item1   Ÿ  (ִ 30)
;    1721 // ----------------------------------------------------------------------------
;    1722 void urx_string(char buff[])
;    1723 {
_urx_string:
;    1724 char ch;
;    1725 int exit_flg = 0,scnt = 0;
;    1726 
;    1727 	com1_rx_eflg = 0;
	CALL __SAVELOCR6
;	*buff -> Y+6
;	ch -> R17
;	exit_flg -> R18,R19
;	scnt -> R20,R21
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	CLR  R2
;    1728 	buff[0] = 0x0;						//  ũ
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
;    1729 	while(exit_flg == 0){
_0x14E:
	MOV  R0,R18
	OR   R0,R19
	BRNE _0x150
;    1730 	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
_0x151:
	TST  R2
	BREQ _0x151
	CLR  R2
;    1731 	    ch = com1_rx_data;					//  Ÿ ε
	MOV  R17,R3
;    1732 	    ch = toupper(ch);					//  ȯ
	CALL SUBOPT_0x35
;    1733 	    if(ch == 0x08){					// BSŰ м
	CPI  R17,8
	BRNE _0x154
;    1734 			if(scnt == 0) putchar(0x07);		//  溸 ۽
	MOV  R0,R20
	OR   R0,R21
	BRNE _0x155
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _putchar
;    1735 			else{					// 1ڸ 
	RJMP _0x156
_0x155:
;    1736 			    putchar(0x08);
	CALL SUBOPT_0x36
;    1737 			    putchar(' ');
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _putchar
;    1738 			    putchar(0x08);
	CALL SUBOPT_0x36
;    1739 			    scnt--;
	__SUBWRN 20,21,1
;    1740 			}
_0x156:
;    1741 	    }
;    1742 	    else if(ch == 0x0d){
	RJMP _0x157
_0x154:
	CPI  R17,13
	BRNE _0x158
;    1743 			exit_flg = 1;				// Ż  ON
	__GETWRN 18,19,1
;    1744 			buff[scnt] = 0x0;
	MOVW R30,R20
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	ST   X,R30
;    1745 			printf("\r\n");
	CALL SUBOPT_0x10
;    1746 	    }
;    1747 	    else{
	RJMP _0x159
_0x158:
;    1748 			buff[scnt++] = ch;			// ڷ 
	CALL SUBOPT_0x22
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
;    1749 			putchar(ch);
	ST   -Y,R17
	RCALL _putchar
;    1750 			if(scnt >= 30){ 			//   ʰ 
	__CPWRN 20,21,30
	BRLT _0x15A
;    1751 			    scnt = 29;
	__GETWRN 20,21,29
;    1752 			    putchar(0x08);
	CALL SUBOPT_0x36
;    1753 			    putchar(0x07);
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _putchar
;    1754 			}
;    1755 	    }
_0x15A:
_0x159:
_0x157:
;    1756 	}
	RJMP _0x14E
_0x150:
;    1757 }
	CALL __LOADLOCR6
	ADIW R28,8
	RET
;    1758 
;    1759 // ========================== ASCII͸ HEXͷ ȯ ==================
;    1760 // [μ] unsigned char buff[]
;    1761 // Item1  ȯ 
;    1762 // [] 0 - 7fffffffh
;    1763 // ----------------------------------------------------------------------------
;    1764 long atoh(char buff[])
;    1765 {
_atoh:
;    1766 char ch;
;    1767 int i = 0;
;    1768 long data = 0;
;    1769 
;    1770 	ch = buff[i++]; 					//  ε
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x15B*2)
	LDI  R31,HIGH(_0x15B*2)
	CALL __INITLOCB
	CALL SUBOPT_0x12
;	*buff -> Y+8
;	ch -> R17
;	i -> R18,R19
;	data -> Y+4
	CALL SUBOPT_0x37
;    1771 	ch = toupper(ch);					// 빮 ȯ
;    1772 	while(ch != 0){
_0x15C:
	CPI  R17,0
	BREQ _0x15E
;    1773 		ch = ch - '0';              			// 0 - 9 ȯ
	SUBI R17,LOW(48)
;    1774 		if(ch > 9) ch = ch - 7;				// A - F ȯ
	CPI  R17,10
	BRLO _0x15F
	SUBI R17,LOW(7)
;    1775 		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
_0x15F:
	CPI  R17,0
	BRLO _0x161
	CPI  R17,16
	BRLO _0x160
_0x161:
	LDI  R17,LOW(0)
;    1776 		else ch = ch & 0x0f;
	RJMP _0x163
_0x160:
	ANDI R17,LOW(15)
;    1777 		data = data << 4;				// ȯ  
_0x163:
	__GETD2S 4
	LDI  R30,LOW(4)
	CALL __LSLD12
	__PUTD1S 4
;    1778 		data |= ch;
	MOV  R30,R17
	__GETD2S 4
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ORD12
	__PUTD1S 4
;    1779 		ch = buff[i++];					//  ε
	CALL SUBOPT_0x37
;    1780 		ch = toupper(ch);				// 빮 ȯ
;    1781 	}
	RJMP _0x15C
_0x15E:
;    1782 	return(data);
	__GETD1S 4
	CALL __LOADLOCR4
	ADIW R28,10
	RET
;    1783 }

_putchar:
_0x167:
	LDS  R30,192
	ANDI R30,LOW(0x20)
	BREQ _0x167
	LD   R30,Y
	STS  198,R30
_0x1CB:
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x16A
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x16C
	__CPWRN 16,17,2
	BRLO _0x16D
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x16C:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x16D:
	RJMP _0x16E
_0x16A:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0x16E:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
_0x16F:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x171
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x175
	CPI  R18,37
	BRNE _0x176
	LDI  R17,LOW(1)
	RJMP _0x177
_0x176:
	CALL SUBOPT_0x38
_0x177:
	RJMP _0x174
_0x175:
	CPI  R30,LOW(0x1)
	BRNE _0x178
	CPI  R18,37
	BRNE _0x179
	CALL SUBOPT_0x38
	RJMP _0x1D5
_0x179:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x17A
	LDI  R16,LOW(1)
	RJMP _0x174
_0x17A:
	CPI  R18,43
	BRNE _0x17B
	LDI  R20,LOW(43)
	RJMP _0x174
_0x17B:
	CPI  R18,32
	BRNE _0x17C
	LDI  R20,LOW(32)
	RJMP _0x174
_0x17C:
	RJMP _0x17D
_0x178:
	CPI  R30,LOW(0x2)
	BRNE _0x17E
_0x17D:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x17F
	ORI  R16,LOW(128)
	RJMP _0x174
_0x17F:
	RJMP _0x180
_0x17E:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x174
_0x180:
	CPI  R18,48
	BRLO _0x183
	CPI  R18,58
	BRLO _0x184
_0x183:
	RJMP _0x182
_0x184:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x174
_0x182:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x188
	CALL SUBOPT_0x39
	LD   R30,X
	CALL SUBOPT_0x3A
	RJMP _0x189
_0x188:
	CPI  R30,LOW(0x73)
	BRNE _0x18B
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3B
	CALL _strlen
	MOV  R17,R30
	RJMP _0x18C
_0x18B:
	CPI  R30,LOW(0x70)
	BRNE _0x18E
	CALL SUBOPT_0x39
	CALL SUBOPT_0x3B
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x18C:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x18F
_0x18E:
	CPI  R30,LOW(0x64)
	BREQ _0x192
	CPI  R30,LOW(0x69)
	BRNE _0x193
_0x192:
	ORI  R16,LOW(4)
	RJMP _0x194
_0x193:
	CPI  R30,LOW(0x75)
	BRNE _0x195
_0x194:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x196
_0x195:
	CPI  R30,LOW(0x58)
	BRNE _0x198
	ORI  R16,LOW(8)
	RJMP _0x199
_0x198:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x1CA
_0x199:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x196:
	SBRS R16,2
	RJMP _0x19B
	CALL SUBOPT_0x39
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x19C
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x19C:
	CPI  R20,0
	BREQ _0x19D
	SUBI R17,-LOW(1)
	RJMP _0x19E
_0x19D:
	ANDI R16,LOW(251)
_0x19E:
	RJMP _0x19F
_0x19B:
	CALL SUBOPT_0x39
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x19F:
_0x18F:
	SBRC R16,0
	RJMP _0x1A0
_0x1A1:
	CP   R17,R21
	BRSH _0x1A3
	SBRS R16,7
	RJMP _0x1A4
	SBRS R16,2
	RJMP _0x1A5
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x1A6
_0x1A5:
	LDI  R18,LOW(48)
_0x1A6:
	RJMP _0x1A7
_0x1A4:
	LDI  R18,LOW(32)
_0x1A7:
	CALL SUBOPT_0x38
	SUBI R21,LOW(1)
	RJMP _0x1A1
_0x1A3:
_0x1A0:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x1A8
_0x1A9:
	CPI  R19,0
	BREQ _0x1AB
	SBRS R16,3
	RJMP _0x1AC
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x1D6
_0x1AC:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x1D6:
	ST   -Y,R30
	CALL SUBOPT_0x3C
	CPI  R21,0
	BREQ _0x1AE
	SUBI R21,LOW(1)
_0x1AE:
	SUBI R19,LOW(1)
	RJMP _0x1A9
_0x1AB:
	RJMP _0x1AF
_0x1A8:
_0x1B1:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x1B3:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x1B5
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x1B3
_0x1B5:
	CPI  R18,58
	BRLO _0x1B6
	SBRS R16,3
	RJMP _0x1B7
	SUBI R18,-LOW(7)
	RJMP _0x1B8
_0x1B7:
	SUBI R18,-LOW(39)
_0x1B8:
_0x1B6:
	SBRC R16,4
	RJMP _0x1BA
	CPI  R18,49
	BRSH _0x1BC
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x1BB
_0x1BC:
	RJMP _0x1D7
_0x1BB:
	CP   R21,R19
	BRLO _0x1C0
	SBRS R16,0
	RJMP _0x1C1
_0x1C0:
	RJMP _0x1BF
_0x1C1:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x1C2
	LDI  R18,LOW(48)
_0x1D7:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x1C3
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x3C
	CPI  R21,0
	BREQ _0x1C4
	SUBI R21,LOW(1)
_0x1C4:
_0x1C3:
_0x1C2:
_0x1BA:
	CALL SUBOPT_0x38
	CPI  R21,0
	BREQ _0x1C5
	SUBI R21,LOW(1)
_0x1C5:
_0x1BF:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x1B2
	RJMP _0x1B1
_0x1B2:
_0x1AF:
	SBRS R16,0
	RJMP _0x1C6
_0x1C7:
	CPI  R21,0
	BREQ _0x1C9
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x3A
	RJMP _0x1C7
_0x1C9:
_0x1C6:
_0x1CA:
_0x189:
_0x1D5:
	LDI  R17,LOW(0)
_0x174:
	RJMP _0x16F
_0x171:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:41 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x2,R30
	OUT  0x1,R30
	OUT  0x5,R30
	OUT  0x4,R30
	OUT  0x8,R30
	OUT  0x7,R30
	OUT  0xB,R30
	OUT  0xA,R30
	OUT  0xE,R30
	OUT  0xD,R30
	OUT  0x11,R30
	OUT  0x10,R30
	OUT  0x14,R30
	OUT  0x13,R30
	STS  261,R30
	STS  260,R30
	STS  264,R30
	STS  263,R30
	STS  267,R30
	STS  266,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	OUT  0x24,R30
	OUT  0x25,R30
	OUT  0x26,R30
	OUT  0x27,R30
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	STS  128,R30
	STS  129,R30
	STS  133,R30
	STS  132,R30
	STS  135,R30
	STS  134,R30
	STS  137,R30
	STS  136,R30
	STS  139,R30
	STS  138,R30
	STS  141,R30
	STS  140,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	STS  182,R30
	STS  176,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	STS  177,R30
	STS  178,R30
	STS  179,R30
	STS  180,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	STS  144,R30
	STS  145,R30
	STS  149,R30
	STS  148,R30
	STS  151,R30
	STS  150,R30
	STS  153,R30
	STS  152,R30
	STS  155,R30
	STS  154,R30
	STS  157,R30
	STS  156,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	STS  160,R30
	STS  161,R30
	STS  165,R30
	STS  164,R30
	STS  167,R30
	STS  166,R30
	STS  169,R30
	STS  168,R30
	STS  171,R30
	STS  170,R30
	STS  173,R30
	STS  172,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	STS  288,R30
	STS  289,R30
	STS  293,R30
	STS  292,R30
	STS  295,R30
	STS  294,R30
	STS  297,R30
	STS  296,R30
	STS  299,R30
	STS  298,R30
	STS  301,R30
	STS  300,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(0)
	STS  105,R30
	STS  106,R30
	OUT  0x1D,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x9:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(246)
	STS  133,R30
	LDI  R30,LOW(59)
	STS  132,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(246)
	STS  149,R30
	LDI  R30,LOW(59)
	STS  148,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(246)
	STS  165,R30
	LDI  R30,LOW(59)
	STS  164,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(246)
	STS  293,R30
	LDI  R30,LOW(59)
	STS  292,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0xF:
	ST   -Y,R30
	ST   -Y,R31
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 125 TIMES, CODE SIZE REDUCTION:493 WORDS
SUBOPT_0x11:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	CALL __SAVELOCR4
	LDI  R18,0
	LDI  R19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x13:
	__POINTW1FN _0,922
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x14:
	__POINTW1FN _0,974
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(0)
	OUT  0x24,R30
	LDI  R30,LOW(5)
	OUT  0x25,R30
	LDI  R30,LOW(99)
	OUT  0x26,R30
	LDI  R30,LOW(0)
	OUT  0x27,R30
	OUT  0x28,R30
	LDS  R30,110
	ORI  R30,1
	STS  110,R30
	CLR  R10
	CLR  R11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x16:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	CALL __LSLW12
	COM  R30
	COM  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x17:
	ST   -Y,R17
	ST   -Y,R16
	LDI  R16,0
	LDI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	__POINTW1FN _0,1314
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(0)
	STS  126,R30
	STS  125,R30
	STS  124,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x1A:
	ST   -Y,R30
	CALL _ad_read
	MOVW R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1B:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,8
	CALL _printf
	ADIW R28,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(255)
	STS  126,R30
	STS  125,R30
	LDI  R30,LOW(0)
	STS  124,R30
	STS  122,R30
	JMP  _main_menu_disp

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1E:
	LD   R30,Y
	STS  124,R30
	LDS  R30,122
	ORI  R30,0x40
	STS  122,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STD  Y+12,R30
	STD  Y+12+1,R31
	MOVW R20,R30
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x20:
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	ST   -Y,R31
	ST   -Y,R30
	CALL _urx_string
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x21:
	__GETWRN 20,21,0
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x22:
	MOVW R30,R20
	__ADDWRN 20,21,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x24:
	MOVW R26,R28
	ADIW R26,44
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	ADIW R26,44
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x25:
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x26:
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoh
	STD  Y+8,R30
	STD  Y+8+1,R31
	MOVW R30,R28
	ADIW R30,44
	ST   -Y,R31
	ST   -Y,R30
	CALL _atoh
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x27:
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	__POINTW1FN _0,3337
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	RJMP SUBOPT_0x1B

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x29:
	__ADDWRN 18,19,1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2A:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _atoh

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2B:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	STD  Y+14,R30
	STD  Y+14+1,R31
	MOVW R20,R30
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2C:
	MOVW R30,R28
	SUBI R30,LOW(-(106))
	SBCI R31,HIGH(-(106))
	ST   -Y,R31
	ST   -Y,R30
	CALL _urx_string
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2D:
	__GETWRN 20,21,0
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ADIW R30,1
	STD  Y+14,R30
	STD  Y+14+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	SUBI R26,LOW(-(76))
	SBCI R27,HIGH(-(76))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2F:
	MOVW R26,R28
	ADIW R26,46
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	MOVW R26,R28
	ADIW R26,46
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x30:
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(106))
	SBCI R27,HIGH(-(106))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x31:
	STD  Y+10,R30
	STD  Y+10+1,R31
	MOVW R30,R28
	ADIW R30,46
	RJMP SUBOPT_0x2A

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x32:
	__ADDWRN 18,19,1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x33:
	__POINTW1FN _0,3692
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	__POINTW1FN _0,975
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x35:
	ST   -Y,R17
	CALL _toupper
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	LDI  R30,LOW(8)
	ST   -Y,R30
	JMP  _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x37:
	MOVW R30,R18
	__ADDWRN 18,19,1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RJMP SUBOPT_0x35

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x38:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x39:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3A:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3B:
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3C:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,15
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_toupper:
	ld   r30,y+
	cpi  r30,'a'
	brlo __toupper0
	cpi  r30,'z'+1
	brcc __toupper0
	subi r30,32
__toupper0:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
